/*******************************************************************/
/* cpp-   Tabula     */
/*  : c:\casfsk\commod.sdf                                  */
/*******************************************************************/

#include "stdafx.h"
#include <stdio.h>
#include <malloc.h>
#include "commod.h"

//    
//: pBuf -   , nPos -   , data -   , size - 
static void ReadBuf(const char* pBuf, int *nPos, void* data, int size)
{
	memcpy(data, pBuf+(*nPos), size);
	(*nPos) += size;	
}

//    
//: pBuf -   , nPos -   , _ch -   
static void ReadStrBuf(const char* pBuf, int *nPos, char* _ch)
{
	WORD len;
	ReadBuf(pBuf, nPos, &len, sizeof(len));
	ReadBuf(pBuf, nPos, _ch, len);
}

//        
static void GetInfoAboutSdf(const char* p_tBuf, struct sTable** pTable)
{
	int		m_nPos	= 0;
	WORD	nCountT	= 0;
	WORD	iT		= 0;
	WORD	iF		= 0;
	BYTE	byrec	= 0;
	DWORD	tPos	= 0; 
	DWORD	off		= 0;
	BYTE	version = 0;
	DWORD	currentRecord = 0;
	
 	ReadBuf(p_tBuf, &m_nPos, &nCountT, sizeof(WORD));
	version = HIBYTE(nCountT);
	if(version != 0){
		ReadBuf(p_tBuf, &m_nPos, &nCountT, sizeof(WORD));
	}

	(*pTable) = (struct sTable*)calloc(nCountT, sizeof(struct sTable));
	
	for(iT = 0; iT < nCountT; iT++){

		(*pTable)[iT].off = m_nPos;

		ReadStrBuf(p_tBuf, &m_nPos, (*pTable)[iT].name);
		ReadBuf(p_tBuf, &m_nPos, &(*pTable)[iT].nCountR, sizeof(DWORD));		

		//    1      ,
		//     
		if(version != 0){
			(*pTable)[iT].p_CurRecord = (DWORD*)&p_tBuf[m_nPos];
			ReadBuf(p_tBuf, &m_nPos, &currentRecord, sizeof(DWORD));
		}

		ReadBuf(p_tBuf, &m_nPos, &(*pTable)[iT].nCountF, sizeof(WORD));
		
		(*pTable)[iT].infoField = (struct sField*)calloc((*pTable)[iT].nCountF, sizeof(struct sField));

		for(iF = 0; iF < (*pTable)[iT].nCountF; iF++){

			(*pTable)[iT].infoField[iF].off = m_nPos;
			ReadStrBuf(p_tBuf, &m_nPos, (*pTable)[iT].infoField[iF].name);
			ReadBuf(p_tBuf, &m_nPos, &(*pTable)[iT].infoField[iF].type, sizeof(WORD));
			ReadBuf(p_tBuf, &m_nPos, &byrec, sizeof(BYTE));

		}

		byrec = 0;		
		ReadBuf(p_tBuf, &m_nPos, &byrec, sizeof(BYTE));

		tPos = m_nPos;
		(*pTable)[iT].offData = m_nPos;

		if(byrec){ // 

			for(iF=0, off=0; iF < (*pTable)[iT].nCountF; iF++){

				(*pTable)[iT].infoField[iF].offData = tPos;
				off += TYPESIZE((*pTable)[iT].infoField[iF].type);

			}

			(*pTable)[iT].SizeOfFields = off;
			m_nPos = tPos + off*(*pTable)[iT].nCountR;

		}

		else{

			for(iF = 0, off = tPos; iF < (*pTable)[iT].nCountF; iF++){

				(*pTable)[iT].infoField[iF].offData = off;
				off += TYPESIZE((*pTable)[iT].infoField[iF].type)*(*pTable)[iT].nCountR;

			}

			m_nPos = off;
			(*pTable)[iT].SizeOfFields = off - tPos;

		}
	}
}

//      
static BYTE GetOffsetDataByRec(const struct sTable* pTable, DWORD index, DWORD* off)
{
	size_t size = _msize((struct sTable*)pTable) / sizeof(struct sTable);
	
	if(index >= 0 && index < size && pTable[index].nCountF > 0)
	{
		(*off) = pTable[index].infoField[0].offData;
		return (BYTE)1;
	}
	else
		return 0;
	
}

//  
static BYTE GetOffsetData(const struct sTable* pTable, const char* field, DWORD* off)
{
	size_t	size		= _msize((struct sTable*)pTable)/sizeof(struct sTable);
	DWORD	iT			= 0;
	WORD	iF			= 0;
	char	_ch1		= '\\';
	BYTE	find_ch1	= 0;
	char	_ch2		= '.';
	BYTE find_ch2		= 0;
	char *res1			= 0;
	char *res2			= 0;
	char *pdest			= 0;
	int len				= -1;

	for(iT = 0; iT < size; iT++){

		for(iF = 0; iF < pTable[iT].nCountF; iF++){

			pdest = strchr(pTable[iT].infoField[iF].name, _ch1);
			if(pdest!=NULL){
				len = pdest - pTable[iT].infoField[iF].name;
				find_ch1 = 1;
				res1 = (char*)calloc((size_t)len + 1, sizeof(char));
				memcpy(res1, pTable[iT].infoField[iF].name, (size_t)len);
				res1[len] = '\0';
			}

			len = -1;
			pdest = strchr(res1, _ch2);
			if(pdest!=NULL){
				len = pdest - res1;
				find_ch2 = 1;
				res2 = (char*)calloc(len + 1, sizeof(char));
				memcpy(res2, res1, len);
				res2[len] = '\0';
			}

			if(find_ch2 && find_ch1){
				if (strcmp(field, res2) == 0){

					(*off) = pTable[iT].infoField[iF].offData;

					free((void*)res2); free((void*)res1);
					return (BYTE)1;
				}
			}

			else if(find_ch1 && !find_ch2){
				if (strcmp(field, res1) == 0){
					(*off) = pTable[iT].infoField[iF].offData;
					free((void*)res1);
					return (BYTE)1;
				}
			}
			
			if(find_ch1) 
				free((void*)res1);

			find_ch1 = 0;

			if(find_ch2) 
				free((void*)res2);

			find_ch2 = 0;
		}
		
	}

	return (BYTE)0;
}

//   
static int FindTable(const struct sTable *pTable, const char *szTableName)
{
	size_t size = _msize((struct sTable*)pTable) / sizeof(struct sTable);
	
	DWORD iT = 0;
	for(/*iT = 0*/; iT < size; iT++){
		
		if(strncmp(pTable[iT].name, szTableName, strlen(szTableName)) == 0)
			return (int)iT;
		
	}
	
	return -1;

}

//     - 
static DWORD* GetTableRecordsAddress(const struct sTable *pTable, DWORD index)
{
	size_t size = _msize((struct sTable*)pTable) / sizeof(struct sTable);
	
	if(index >= 0 && index < size)
		return pTable[index].p_CurRecord;
	else
		return 0;
}

//    - 
static DWORD GetTableRecordsMax(const struct sTable *pTable, DWORD index)
{
	size_t size = _msize((struct sTable*)pTable) / sizeof(struct sTable);
	
	if(index >= 0 && index < size)
		return pTable[index].nCountR;
	else
		return 0;
}

//  
static void DeleteInfoSdf(struct sTable** pTable)
{
	size_t size	= 0;
	DWORD iT	= 0;
	
	size = _msize((*pTable))/sizeof(struct sTable);

	for(iT = 0; iT < size; iT++)
 		free((*pTable)[iT].infoField);		

	if(size)
  		free((*pTable));
}

//      
DWORD rpn_type_max = 0;
DWORD *p_rpn_type = NULL;
int    *rpn_id;
c100   *rpn_name;
float  *rpn_Snom;
float  *rpn_UmaxNom;
float  *rpn_UminNom;
float  *rpn_H;
short  *rpn_Nanc;
BYTE   *rpn_NneutralAnc;
float  *rpn_DDopVn;
float  *rpn_DDopSn;
float  *rpn_DDopNn;
short  *rpn_arnt_p;

//     cxn
DWORD cxn_max = 0;
DWORD *p_cxn = NULL;
float  *A0;
float  *A1;
float  *A2;
float  *AF;
float  *B0;
float  *B1;
float  *B2;
float  *BF;

//      
DWORD Param_Lim_Q_max = 0;
DWORD *p_Param_Lim_Q = NULL;
int    *IdLim;
c100   *NameParamG;
float  *cosF;
float  *Qnom;
float  *Xd;
float  *kI;
float  *kE;
float  *kP1;
float  *Q1;
float  *kP2;
float  *Q2;
float  *kP3;
float  *Q3;

//     
DWORD sections_max = 0;
DWORD *p_sections = NULL;
short  *sec_Id;
c100   *sec_name;
c50    *sec_ForDirName;
c50    *sec_RevDirName;
float  *sec_flow;
float  *sec_ForLim;
float  *sec_RevLim;
float  *sec_flowR;
float  *sec_lossA;
float  *sec_lossR;
float  *sec_nflow;

//     sections_mem
DWORD sections_mem_max = 0;
DWORD *p_sections_mem = NULL;
short  *secmem_IdSec;
int    *secmem_IdLine;
int    *secmem_IdNode1;
int    *secmem_IdNode2;
float  *secmem_DiffPh;

//     fcmp
DWORD fcmp_max = 0;
DWORD *p_fcmp = NULL;
int    *fcmp_k1;
int    *fcmp_k2;

//     Reg
DWORD Reg_max = 0;
DWORD *p_Reg = NULL;
short  *TechNumReg;
c50    *NameRegions;
float  *RegGenAct;
float  *RegGenRea;
float  *RegLoadAct;
float  *RegLoadRea;
float  *RegSalAct;
float  *RegSalRea;
float  *USP;
float  *VALS;
float  *KFR;
float  *FPRS;
float  *FINS;
float  *PRMAX;
float  *PRMIN;
char   *QREG_MAX;
char   *QREG_MIN;
float  *PRSUM;
float  *UCP;
float  *FCP;
float  *UIN;

//     ts
DWORD op_ts_max = 0;
DWORD *p_op_ts = NULL;
int    *op_ts_id;
c50    *op_ts_name;
c30    *op_ts_SubDispName;
BYTE   *op_ts_type;
BYTE   *op_ts_state;
BYTE   *op_ts_norm;
BYTE   *op_ts_past;
BYTE   *op_ts_kvit;
BYTE   *op_ts_alarm;
int    *op_ts_beg;
int    *op_ts_end;
BYTE   *corrected;
float  *op_ts_u1;
float  *op_ts_u2;
short  *op_ts_SubId;
int    *op_ts_SubInd;

//       
DWORD rpnTab_type_max = 0;
DWORD *p_rpnTab_type = NULL;
int    *rpnTab_id;
float  *ANC1;
float  *ANC2;
float  *ANC3;
float  *ANC4;
float  *ANC5;
float  *ANC6;
float  *ANC7;
float  *ANC8;
float  *ANC9;
float  *ANC10;
float  *ANC11;
float  *ANC12;
float  *ANC13;
float  *ANC14;
float  *ANC15;
float  *ANC16;
float  *ANC17;
float  *ANC18;
float  *ANC19;
float  *ANC20;

//     3-  
DWORD trans_max = 0;
DWORD *p_trans = NULL;
int    *trans_id;
short  *trans_SubId;
int    *trans_line1;
int    *trans_line2;
int    *trans_line3;
float  *trans_per1;
float  *trans_per2;
float  *trans_per3;
float  *trans_peq1;
float  *trans_peq2;
float  *trans_peq3;
float  *trans_tok1;
float  *trans_tok2;
float  *trans_tok3;

//      
DWORD CDU_max = 0;
DWORD *p_CDU = NULL;
BYTE   *sign_CDU;
c255   *FileName_CDU;
float  *fTime_CDU;
short  *LoadOnce;

//     blocks
DWORD blocks_max = 0;
DWORD *p_blocks = NULL;
int    *blocks_nug;
BYTE   *blocks_num;
short  *blocks_ts1;
short  *blocks_ts2;
short  *blocks_ts3;
short  *blocks_ts4;
short  *blocks_ts5;
short  *blocks_ts6;
short  *blocks_ts7;
short  *blocks_ts8;
BYTE   *blocks_connect_type;
BYTE   *blocks_state;
double *blocks_gen;

//     shunts
DWORD shunts_max = 0;
DWORD *p_shunts = NULL;
int    *shunts_nod;
BYTE   *shunts_num;
short  *shunts_ts1;
short  *shunts_ts2;
short  *shunts_ts3;
short  *shunts_ts4;
short  *shunts_ts5;
short  *shunts_ts6;
short  *shunts_ts7;
short  *shunts_ts8;
BYTE   *shunts_connect_type;
BYTE   *shunts_state;

//     UKZ
DWORD UKZ_max = 0;
DWORD *p_UKZ = NULL;
short  *UNOB1;
short  *UNOB2;
short  *UNOB3;
short  *UNOB4;
short  *UNOB5;
short  *UNOB6;
short  *UNOB7;
short  *UNOB8;
float  *UKZ0;
float  *UKZ1;
float  *UKZ4;
float  *UKZ5;

//     LKZ
DWORD LKZ_max = 0;
DWORD *p_LKZ = NULL;
short  *NOB1;
short  *NOB2;
short  *NOB3;
float  *TKZ0;
float  *TKZ1;
float  *TKZ2;
float  *TKZ3;
float  *TKZ4;
float  *TKZ5;
float  *TKZ6;
float  *TKZ7;

//     . . .
DWORD n_tek_max = 0;
DWORD *p_n_tek = NULL;
int    *NON;
c30    *NAN;
float  *DOL;
float  *UN;
float  *FAN;
float  *FN;
float  *BLC;
float  *PNA;
float  *BLR;
float  *PNQ;
short  *TUN;
short  *KSN;
float  *SNAS;
float  *SNRS;
float  *SNA;
float  *SNR;
char   *QBL;
short  *REN;
short  *DAD;
float  *PON;
short  *NRN;
short  *NRN_TR;
float  *NL_InjectionP;
float  *NL_InjectionQ;
char   *QSN;
char   *QFRN;
short  *TDA;
float  *SAD;
float  *QAD;
float  *RMAD;
float  *PAD;
float  *FAD;
float  *UIZ;
int    *BKRN;
float  *NL_UPMax;
float  *NL_UPMin;
float  *NL_UAMax;
float  *NL_UAMin;
float  *EMAL;
float  *MMAL;
float  *SiAD;

//     . . .
DWORD g_tek_max = 0;
DWORD *p_g_tek = NULL;
int    *NUG;
c30    *NAG;
float  *UU;
float  *FAZA;
float  *F;
float  *SAL;
float  *AK;
float  *AKI;
float  *PAG;
float  *BAG;
float  *UGN;
float  *UMAX;
float  *UMIN;
float  *DUG;
float  *FUG;
float  *PQG;
float  *QKS;
short  *KSG;
float  *SGAS;
float  *SGRS;
float  *SGA;
float  *SGR;
float  *UUR;
float  *UUS;
float  *UF;
float  *UO;
char   *QSG;
short  *NTIG;
short  *REG_REG;
short  *REG_REG_TR;
char   *QGN;
float  *APBN;
float  *APB;
float  *NG_InjectionP;
float  *NG_InjectionQ;
char   *TUG;
char   *QFRG;
float  *QMAX;
float  *QMIN;
short  *PMIN;
short  *PMAX;
short  *PAFR;
short  *KBL;
short  *KBLN;
short  *TDD;
short  *NDT;
short  *NDG;
int    *BKBG;
int    *BKBN;
int    *BKRG;
float  *PRICE;
float  *REA;
float  *UG1;
float  *G0;
float  *G1;
float  *G2;
float  *G3;
float  *uff;
float  *uqp;
float  *uup;
float  *ft;
float  *fg;
float  *fa;
float  *ff;
float  *BQG;
float  *PDD;
short  *SV;
float  *UGP;
float  *DUR;
float  *AKF;
float  *AKP;
int    *X_NODE;
int    *Y_NODE;
float  *NG_UPMax;
float  *NG_UPMin;
float  *NG_UAMax;
float  *NG_UAMin;
float  *NG_PPMax;
float  *NG_PPMin;
float  *NG_PAMax;
float  *NG_PAMin;
short  *SubId;
float  *KoefCor;
BYTE   *GDEAD;
float  *Pbal;
float  *Qbal;
BYTE   *typeLimQ;
short  *AKM;
short  *ADIN;
float  *AKTEK;
float  *bnp;
float  *bb;
BYTE   *g_IsTrans;
float  *NFU;
float  *UUC;

//     modtime
DWORD modtime_max = 0;
DWORD *p_modtime = NULL;
double *timeM;
short  *MaxdtCounter;
float  *DT;

//      
DWORD All_nodes_max = 0;
DWORD *p_All_nodes = NULL;
int    *NGN;
c30    *NAGN;
float  *RND;
float  *SS;
float  *SAR;
float  *SAQ;
float  *EMU;
float  *RMU;
float  *FANP;
float  *UUGN;
float  *UGNA;
float  *FFGN;
short  *AllRegNodes;
short  *FLAG_NODE;
short  *X_sh;
short  *Y_sh;
BYTE   *DEAD;
float  *RND_UUGN;
float  *RND_FANP;
BYTE   *GRN;
short  *X_sh1;
short  *Y_sh1;

//      
DWORD NameSch_max = 0;
DWORD *p_NameSch = NULL;
c50    *NAME;
c128   *Comment;
c128   *File_schm;
int    *SupportNodeTech;
short  *NU;
short  *MM;
short  *N1;

//     
DWORD Upravl_max = 0;
DWORD *p_Upravl = NULL;
char   *SZ;
int    *SZINT;
float  *SZFLOAT;

//     
DWORD Upravl2_max = 0;
DWORD *p_Upravl2 = NULL;
BYTE   *AfterLoadPause;
int    *BaseNug;
float  *FreqInBase;

//     . . 
DWORD L_tek_max = 0;
DWORD *p_L_tek = NULL;
int    *Lnum;
int    *KG_ind;
int    *KL_ind;
int    *KG_ish;
int    *KL_ish;
c12    *NAL;
BYTE   *LType;
short  *NLI;
short  *NRL;
float  *PER;
float  *PER1;
float  *PER2;
float  *POT;
float  *PEQ;
float  *PEQ1;
float  *PEQ2;
float  *PQT;
float  *TOK1;
float  *TOK_START;
float  *TOK_END;
float  *TRA;
float  *TRK;
float  *TRKM;
char   *BKL;
BYTE   *BKL1;
BYTE   *BKL2;
BYTE   *LCH1;
BYTE   *LCH2;
char   *QDA;
char   *QON;
short  *OL;
float  *SIR;
float  *SIG;
float  *EMK;
float  *KORON;
float  *NFL;
float  *QFL;
float  *NFQ;
BYTE   *BFL;
int    *NTIL;
short  *PRL;
short  *LnumD;
float  *L_PPMax;
float  *L_PPMin;
float  *L_PAMax;
float  *L_PAMin;
float  *L_IPMax;
float  *L_IPMin;
float  *L_IAMax;
float  *L_IAMin;
float  *U_start;
float  *U_end;
c100   *NALF;
BYTE   *INVAL;
float  *RND_PER1;
float  *RND_PER2;
float  *RND_PEQ1;
float  *RND_PEQ2;
float  *RND_TOK1;
float  *RND_FAZA_TOK1;
float  *RND_TOK2;
float  *RND_FAZA_TOK2;
short  *L_SubId1;
short  *L_SubId2;
short  *NomAnc;
BYTE   *LGRN1;
BYTE   *LGRN2;
BYTE   *LDEAD1;
BYTE   *LDEAD2;
float  *L_unom1;
float  *L_unom2;
BYTE   *L_istrans;

//     L_ts
DWORD L_ts_max = 0;
DWORD *p_L_ts = NULL;
short  *L_ts_Begin1;
short  *L_ts_Begin2;
short  *L_ts_Begin3;
short  *L_ts_Begin4;
short  *L_ts_Begin5;
short  *L_ts_Begin6;
short  *L_ts_Begin7;
short  *L_ts_Begin8;
short  *L_ts_End1;
short  *L_ts_End2;
short  *L_ts_End3;
short  *L_ts_End4;
short  *L_ts_End5;
short  *L_ts_End6;
short  *L_ts_End7;
short  *L_ts_End8;
int    *L_ts_begin;
int    *L_ts_end;
short  *L_ts_paralel;
BYTE   *L_ts_type_begin;
BYTE   *L_ts_type_end;

//   
int commodError(HANDLE hMutex)
{
	p_rpn_type = NULL;
	p_cxn = NULL;
	p_Param_Lim_Q = NULL;
	p_sections = NULL;
	p_sections_mem = NULL;
	p_fcmp = NULL;
	p_Reg = NULL;
	p_op_ts = NULL;
	p_rpnTab_type = NULL;
	p_trans = NULL;
	p_CDU = NULL;
	p_blocks = NULL;
	p_shunts = NULL;
	p_UKZ = NULL;
	p_LKZ = NULL;
	p_n_tek = NULL;
	p_g_tek = NULL;
	p_modtime = NULL;
	p_All_nodes = NULL;
	p_NameSch = NULL;
	p_Upravl = NULL;
	p_Upravl2 = NULL;
	p_L_tek = NULL;
	p_L_ts = NULL;

	rpn_type_max = 0;
	cxn_max = 0;
	Param_Lim_Q_max = 0;
	sections_max = 0;
	sections_mem_max = 0;
	fcmp_max = 0;
	Reg_max = 0;
	op_ts_max = 0;
	rpnTab_type_max = 0;
	trans_max = 0;
	CDU_max = 0;
	blocks_max = 0;
	shunts_max = 0;
	UKZ_max = 0;
	LKZ_max = 0;
	n_tek_max = 0;
	g_tek_max = 0;
	modtime_max = 0;
	All_nodes_max = 0;
	NameSch_max = 0;
	Upravl_max = 0;
	Upravl2_max = 0;
	L_tek_max = 0;
	L_ts_max = 0;

	rpn_id = NULL;
	rpn_name = NULL;
	rpn_Snom = NULL;
	rpn_UmaxNom = NULL;
	rpn_UminNom = NULL;
	rpn_H = NULL;
	rpn_Nanc = NULL;
	rpn_NneutralAnc = NULL;
	rpn_DDopVn = NULL;
	rpn_DDopSn = NULL;
	rpn_DDopNn = NULL;
	rpn_arnt_p = NULL;
	A0 = NULL;
	A1 = NULL;
	A2 = NULL;
	AF = NULL;
	B0 = NULL;
	B1 = NULL;
	B2 = NULL;
	BF = NULL;
	IdLim = NULL;
	NameParamG = NULL;
	cosF = NULL;
	Qnom = NULL;
	Xd = NULL;
	kI = NULL;
	kE = NULL;
	kP1 = NULL;
	Q1 = NULL;
	kP2 = NULL;
	Q2 = NULL;
	kP3 = NULL;
	Q3 = NULL;
	sec_Id = NULL;
	sec_name = NULL;
	sec_ForDirName = NULL;
	sec_RevDirName = NULL;
	sec_flow = NULL;
	sec_ForLim = NULL;
	sec_RevLim = NULL;
	sec_flowR = NULL;
	sec_lossA = NULL;
	sec_lossR = NULL;
	sec_nflow = NULL;
	secmem_IdSec = NULL;
	secmem_IdLine = NULL;
	secmem_IdNode1 = NULL;
	secmem_IdNode2 = NULL;
	secmem_DiffPh = NULL;
	fcmp_k1 = NULL;
	fcmp_k2 = NULL;
	TechNumReg = NULL;
	NameRegions = NULL;
	RegGenAct = NULL;
	RegGenRea = NULL;
	RegLoadAct = NULL;
	RegLoadRea = NULL;
	RegSalAct = NULL;
	RegSalRea = NULL;
	USP = NULL;
	VALS = NULL;
	KFR = NULL;
	FPRS = NULL;
	FINS = NULL;
	PRMAX = NULL;
	PRMIN = NULL;
	QREG_MAX = NULL;
	QREG_MIN = NULL;
	PRSUM = NULL;
	UCP = NULL;
	FCP = NULL;
	UIN = NULL;
	op_ts_id = NULL;
	op_ts_name = NULL;
	op_ts_SubDispName = NULL;
	op_ts_type = NULL;
	op_ts_state = NULL;
	op_ts_norm = NULL;
	op_ts_past = NULL;
	op_ts_kvit = NULL;
	op_ts_alarm = NULL;
	op_ts_beg = NULL;
	op_ts_end = NULL;
	corrected = NULL;
	op_ts_u1 = NULL;
	op_ts_u2 = NULL;
	op_ts_SubId = NULL;
	op_ts_SubInd = NULL;
	rpnTab_id = NULL;
	ANC1 = NULL;
	ANC2 = NULL;
	ANC3 = NULL;
	ANC4 = NULL;
	ANC5 = NULL;
	ANC6 = NULL;
	ANC7 = NULL;
	ANC8 = NULL;
	ANC9 = NULL;
	ANC10 = NULL;
	ANC11 = NULL;
	ANC12 = NULL;
	ANC13 = NULL;
	ANC14 = NULL;
	ANC15 = NULL;
	ANC16 = NULL;
	ANC17 = NULL;
	ANC18 = NULL;
	ANC19 = NULL;
	ANC20 = NULL;
	trans_id = NULL;
	trans_SubId = NULL;
	trans_line1 = NULL;
	trans_line2 = NULL;
	trans_line3 = NULL;
	trans_per1 = NULL;
	trans_per2 = NULL;
	trans_per3 = NULL;
	trans_peq1 = NULL;
	trans_peq2 = NULL;
	trans_peq3 = NULL;
	trans_tok1 = NULL;
	trans_tok2 = NULL;
	trans_tok3 = NULL;
	sign_CDU = NULL;
	FileName_CDU = NULL;
	fTime_CDU = NULL;
	LoadOnce = NULL;
	blocks_nug = NULL;
	blocks_num = NULL;
	blocks_ts1 = NULL;
	blocks_ts2 = NULL;
	blocks_ts3 = NULL;
	blocks_ts4 = NULL;
	blocks_ts5 = NULL;
	blocks_ts6 = NULL;
	blocks_ts7 = NULL;
	blocks_ts8 = NULL;
	blocks_connect_type = NULL;
	blocks_state = NULL;
	blocks_gen = NULL;
	shunts_nod = NULL;
	shunts_num = NULL;
	shunts_ts1 = NULL;
	shunts_ts2 = NULL;
	shunts_ts3 = NULL;
	shunts_ts4 = NULL;
	shunts_ts5 = NULL;
	shunts_ts6 = NULL;
	shunts_ts7 = NULL;
	shunts_ts8 = NULL;
	shunts_connect_type = NULL;
	shunts_state = NULL;
	UNOB1 = NULL;
	UNOB2 = NULL;
	UNOB3 = NULL;
	UNOB4 = NULL;
	UNOB5 = NULL;
	UNOB6 = NULL;
	UNOB7 = NULL;
	UNOB8 = NULL;
	UKZ0 = NULL;
	UKZ1 = NULL;
	UKZ4 = NULL;
	UKZ5 = NULL;
	NOB1 = NULL;
	NOB2 = NULL;
	NOB3 = NULL;
	TKZ0 = NULL;
	TKZ1 = NULL;
	TKZ2 = NULL;
	TKZ3 = NULL;
	TKZ4 = NULL;
	TKZ5 = NULL;
	TKZ6 = NULL;
	TKZ7 = NULL;
	NON = NULL;
	NAN = NULL;
	DOL = NULL;
	UN = NULL;
	FAN = NULL;
	FN = NULL;
	BLC = NULL;
	PNA = NULL;
	BLR = NULL;
	PNQ = NULL;
	TUN = NULL;
	KSN = NULL;
	SNAS = NULL;
	SNRS = NULL;
	SNA = NULL;
	SNR = NULL;
	QBL = NULL;
	REN = NULL;
	DAD = NULL;
	PON = NULL;
	NRN = NULL;
	NRN_TR = NULL;
	NL_InjectionP = NULL;
	NL_InjectionQ = NULL;
	QSN = NULL;
	QFRN = NULL;
	TDA = NULL;
	SAD = NULL;
	QAD = NULL;
	RMAD = NULL;
	PAD = NULL;
	FAD = NULL;
	UIZ = NULL;
	BKRN = NULL;
	NL_UPMax = NULL;
	NL_UPMin = NULL;
	NL_UAMax = NULL;
	NL_UAMin = NULL;
	EMAL = NULL;
	MMAL = NULL;
	SiAD = NULL;
	NUG = NULL;
	NAG = NULL;
	UU = NULL;
	FAZA = NULL;
	F = NULL;
	SAL = NULL;
	AK = NULL;
	AKI = NULL;
	PAG = NULL;
	BAG = NULL;
	UGN = NULL;
	UMAX = NULL;
	UMIN = NULL;
	DUG = NULL;
	FUG = NULL;
	PQG = NULL;
	QKS = NULL;
	KSG = NULL;
	SGAS = NULL;
	SGRS = NULL;
	SGA = NULL;
	SGR = NULL;
	UUR = NULL;
	UUS = NULL;
	UF = NULL;
	UO = NULL;
	QSG = NULL;
	NTIG = NULL;
	REG_REG = NULL;
	REG_REG_TR = NULL;
	QGN = NULL;
	APBN = NULL;
	APB = NULL;
	NG_InjectionP = NULL;
	NG_InjectionQ = NULL;
	TUG = NULL;
	QFRG = NULL;
	QMAX = NULL;
	QMIN = NULL;
	PMIN = NULL;
	PMAX = NULL;
	PAFR = NULL;
	KBL = NULL;
	KBLN = NULL;
	TDD = NULL;
	NDT = NULL;
	NDG = NULL;
	BKBG = NULL;
	BKBN = NULL;
	BKRG = NULL;
	PRICE = NULL;
	REA = NULL;
	UG1 = NULL;
	G0 = NULL;
	G1 = NULL;
	G2 = NULL;
	G3 = NULL;
	uff = NULL;
	uqp = NULL;
	uup = NULL;
	ft = NULL;
	fg = NULL;
	fa = NULL;
	ff = NULL;
	BQG = NULL;
	PDD = NULL;
	SV = NULL;
	UGP = NULL;
	DUR = NULL;
	AKF = NULL;
	AKP = NULL;
	X_NODE = NULL;
	Y_NODE = NULL;
	NG_UPMax = NULL;
	NG_UPMin = NULL;
	NG_UAMax = NULL;
	NG_UAMin = NULL;
	NG_PPMax = NULL;
	NG_PPMin = NULL;
	NG_PAMax = NULL;
	NG_PAMin = NULL;
	SubId = NULL;
	KoefCor = NULL;
	GDEAD = NULL;
	Pbal = NULL;
	Qbal = NULL;
	typeLimQ = NULL;
	AKM = NULL;
	ADIN = NULL;
	AKTEK = NULL;
	bnp = NULL;
	bb = NULL;
	g_IsTrans = NULL;
	NFU = NULL;
	UUC = NULL;
	timeM = NULL;
	MaxdtCounter = NULL;
	DT = NULL;
	NGN = NULL;
	NAGN = NULL;
	RND = NULL;
	SS = NULL;
	SAR = NULL;
	SAQ = NULL;
	EMU = NULL;
	RMU = NULL;
	FANP = NULL;
	UUGN = NULL;
	UGNA = NULL;
	FFGN = NULL;
	AllRegNodes = NULL;
	FLAG_NODE = NULL;
	X_sh = NULL;
	Y_sh = NULL;
	DEAD = NULL;
	RND_UUGN = NULL;
	RND_FANP = NULL;
	GRN = NULL;
	X_sh1 = NULL;
	Y_sh1 = NULL;
	NAME = NULL;
	Comment = NULL;
	File_schm = NULL;
	SupportNodeTech = NULL;
	NU = NULL;
	MM = NULL;
	N1 = NULL;
	SZ = NULL;
	SZINT = NULL;
	SZFLOAT = NULL;
	AfterLoadPause = NULL;
	BaseNug = NULL;
	FreqInBase = NULL;
	Lnum = NULL;
	KG_ind = NULL;
	KL_ind = NULL;
	KG_ish = NULL;
	KL_ish = NULL;
	NAL = NULL;
	LType = NULL;
	NLI = NULL;
	NRL = NULL;
	PER = NULL;
	PER1 = NULL;
	PER2 = NULL;
	POT = NULL;
	PEQ = NULL;
	PEQ1 = NULL;
	PEQ2 = NULL;
	PQT = NULL;
	TOK1 = NULL;
	TOK_START = NULL;
	TOK_END = NULL;
	TRA = NULL;
	TRK = NULL;
	TRKM = NULL;
	BKL = NULL;
	BKL1 = NULL;
	BKL2 = NULL;
	LCH1 = NULL;
	LCH2 = NULL;
	QDA = NULL;
	QON = NULL;
	OL = NULL;
	SIR = NULL;
	SIG = NULL;
	EMK = NULL;
	KORON = NULL;
	NFL = NULL;
	QFL = NULL;
	NFQ = NULL;
	BFL = NULL;
	NTIL = NULL;
	PRL = NULL;
	LnumD = NULL;
	L_PPMax = NULL;
	L_PPMin = NULL;
	L_PAMax = NULL;
	L_PAMin = NULL;
	L_IPMax = NULL;
	L_IPMin = NULL;
	L_IAMax = NULL;
	L_IAMin = NULL;
	U_start = NULL;
	U_end = NULL;
	NALF = NULL;
	INVAL = NULL;
	RND_PER1 = NULL;
	RND_PER2 = NULL;
	RND_PEQ1 = NULL;
	RND_PEQ2 = NULL;
	RND_TOK1 = NULL;
	RND_FAZA_TOK1 = NULL;
	RND_TOK2 = NULL;
	RND_FAZA_TOK2 = NULL;
	L_SubId1 = NULL;
	L_SubId2 = NULL;
	NomAnc = NULL;
	LGRN1 = NULL;
	LGRN2 = NULL;
	LDEAD1 = NULL;
	LDEAD2 = NULL;
	L_unom1 = NULL;
	L_unom2 = NULL;
	L_istrans = NULL;
	L_ts_Begin1 = NULL;
	L_ts_Begin2 = NULL;
	L_ts_Begin3 = NULL;
	L_ts_Begin4 = NULL;
	L_ts_Begin5 = NULL;
	L_ts_Begin6 = NULL;
	L_ts_Begin7 = NULL;
	L_ts_Begin8 = NULL;
	L_ts_End1 = NULL;
	L_ts_End2 = NULL;
	L_ts_End3 = NULL;
	L_ts_End4 = NULL;
	L_ts_End5 = NULL;
	L_ts_End6 = NULL;
	L_ts_End7 = NULL;
	L_ts_End8 = NULL;
	L_ts_begin = NULL;
	L_ts_end = NULL;
	L_ts_paralel = NULL;
	L_ts_type_begin = NULL;
	L_ts_type_end = NULL;

	ReleaseMutex(hMutex);
	CloseHandle(hMutex);

	return 0;
}

LPVOID commodBuf = NULL;
HANDLE commodMap = NULL;

struct sTable *pcommodSdf = NULL;

int commodOpen(const char* name)
{
	DWORD off = 0;
	BYTE offset = 0;
	int result = 0;
	char *p = 0;
	char *pBase = 0;
	char fname[MAX_PATH] = {0};
	char mname[MAX_PATH] = {0};
	HANDLE hMutex     = 0;
	HANDLE hFile      = 0;
	DWORD  sizeFile   = 0;
	int   indexTable = -1;

	if(name == NULL)
		strcpy(fname, "commod.sdf");
	else
		strcpy(fname, (const char*)name);

	if(strchr(fname, ':') == NULL){
		char dir[MAX_PATH] = {0};
		GetModuleFileNameA(NULL, dir, sizeof(dir));
		*(strrchr(dir, '\\') + 1) = '\0';
		strcat(dir, fname);
		strcpy(fname,dir);
	}

	GetFullPathNameA(fname, sizeof(mname), mname, &p);
	//GetLongPathName(fname, mname, sizeof(mname));
	_strlwr(mname);

	p=mname;
	while(*p){
		if(*p<'0') *p= '_';
		if(*p>'9' && *p<'A') *p= '_';
		if(*p>'z') *p= '_';
		if(*p>'Z' && *p<'a') *p= '_';
		p++;
	}

	hMutex = CreateMutexA(NULL, FALSE, "__commod_mutex");

	WaitForSingleObject(hMutex, INFINITE);

	commodMap = OpenFileMappingA(FILE_MAP_ALL_ACCESS, FALSE, mname);

	if(commodMap == NULL){

		hFile = CreateFileA(fname, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
		if(hFile == INVALID_HANDLE_VALUE)
			return commodError(hMutex);

		sizeFile = GetFileSize(hFile, NULL);

		commodMap = CreateFileMappingA(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, sizeFile, mname);
		if(commodMap == NULL)
			return commodError(hMutex);

		commodBuf = MapViewOfFile(commodMap, FILE_MAP_ALL_ACCESS, 0, 0, 0);
		if(commodBuf == NULL)
			return commodError(hMutex);

		if(!ReadFile(hFile, commodBuf, sizeFile, &sizeFile, NULL))
			return commodError(hMutex);

		CloseHandle(hFile);

		result = 2;

	}
	else{

		commodBuf = MapViewOfFile(commodMap, FILE_MAP_ALL_ACCESS, 0, 0, 0);
		if(commodBuf == NULL)
			return commodError(hMutex);

		result = 1;
	}

	pBase = (char*)commodBuf;

	GetInfoAboutSdf(pBase, &pcommodSdf);

	indexTable = FindTable(pcommodSdf, "rpn_type");
	if(indexTable == -1)
		return commodError(hMutex);
	else{
		p_rpn_type = GetTableRecordsAddress(pcommodSdf, indexTable);
		rpn_type_max = GetTableRecordsMax(pcommodSdf, indexTable);
	}

	indexTable = FindTable(pcommodSdf, "cxn");
	if(indexTable == -1)
		return commodError(hMutex);
	else{
		p_cxn = GetTableRecordsAddress(pcommodSdf, indexTable);
		cxn_max = GetTableRecordsMax(pcommodSdf, indexTable);
	}

	indexTable = FindTable(pcommodSdf, "Param_Lim_Q");
	if(indexTable == -1)
		return commodError(hMutex);
	else{
		p_Param_Lim_Q = GetTableRecordsAddress(pcommodSdf, indexTable);
		Param_Lim_Q_max = GetTableRecordsMax(pcommodSdf, indexTable);
	}

	indexTable = FindTable(pcommodSdf, "sections");
	if(indexTable == -1)
		return commodError(hMutex);
	else{
		p_sections = GetTableRecordsAddress(pcommodSdf, indexTable);
		sections_max = GetTableRecordsMax(pcommodSdf, indexTable);
	}

	indexTable = FindTable(pcommodSdf, "sections_mem");
	if(indexTable == -1)
		return commodError(hMutex);
	else{
		p_sections_mem = GetTableRecordsAddress(pcommodSdf, indexTable);
		sections_mem_max = GetTableRecordsMax(pcommodSdf, indexTable);
	}

	indexTable = FindTable(pcommodSdf, "fcmp");
	if(indexTable == -1)
		return commodError(hMutex);
	else{
		p_fcmp = GetTableRecordsAddress(pcommodSdf, indexTable);
		fcmp_max = GetTableRecordsMax(pcommodSdf, indexTable);
	}

	indexTable = FindTable(pcommodSdf, "Reg");
	if(indexTable == -1)
		return commodError(hMutex);
	else{
		p_Reg = GetTableRecordsAddress(pcommodSdf, indexTable);
		Reg_max = GetTableRecordsMax(pcommodSdf, indexTable);
	}

	indexTable = FindTable(pcommodSdf, "op_ts");
	if(indexTable == -1)
		return commodError(hMutex);
	else{
		p_op_ts = GetTableRecordsAddress(pcommodSdf, indexTable);
		op_ts_max = GetTableRecordsMax(pcommodSdf, indexTable);
	}

	indexTable = FindTable(pcommodSdf, "rpnTab_type");
	if(indexTable == -1)
		return commodError(hMutex);
	else{
		p_rpnTab_type = GetTableRecordsAddress(pcommodSdf, indexTable);
		rpnTab_type_max = GetTableRecordsMax(pcommodSdf, indexTable);
	}

	indexTable = FindTable(pcommodSdf, "trans");
	if(indexTable == -1)
		return commodError(hMutex);
	else{
		p_trans = GetTableRecordsAddress(pcommodSdf, indexTable);
		trans_max = GetTableRecordsMax(pcommodSdf, indexTable);
	}

	indexTable = FindTable(pcommodSdf, "CDU");
	if(indexTable == -1)
		return commodError(hMutex);
	else{
		p_CDU = GetTableRecordsAddress(pcommodSdf, indexTable);
		CDU_max = GetTableRecordsMax(pcommodSdf, indexTable);
	}

	indexTable = FindTable(pcommodSdf, "blocks");
	if(indexTable == -1)
		return commodError(hMutex);
	else{
		p_blocks = GetTableRecordsAddress(pcommodSdf, indexTable);
		blocks_max = GetTableRecordsMax(pcommodSdf, indexTable);
	}

	indexTable = FindTable(pcommodSdf, "shunts");
	if(indexTable == -1)
		return commodError(hMutex);
	else{
		p_shunts = GetTableRecordsAddress(pcommodSdf, indexTable);
		shunts_max = GetTableRecordsMax(pcommodSdf, indexTable);
	}

	indexTable = FindTable(pcommodSdf, "UKZ");
	if(indexTable == -1)
		return commodError(hMutex);
	else{
		p_UKZ = GetTableRecordsAddress(pcommodSdf, indexTable);
		UKZ_max = GetTableRecordsMax(pcommodSdf, indexTable);
	}

	indexTable = FindTable(pcommodSdf, "LKZ");
	if(indexTable == -1)
		return commodError(hMutex);
	else{
		p_LKZ = GetTableRecordsAddress(pcommodSdf, indexTable);
		LKZ_max = GetTableRecordsMax(pcommodSdf, indexTable);
	}

	indexTable = FindTable(pcommodSdf, "n_tek");
	if(indexTable == -1)
		return commodError(hMutex);
	else{
		p_n_tek = GetTableRecordsAddress(pcommodSdf, indexTable);
		n_tek_max = GetTableRecordsMax(pcommodSdf, indexTable);
	}

	indexTable = FindTable(pcommodSdf, "g_tek");
	if(indexTable == -1)
		return commodError(hMutex);
	else{
		p_g_tek = GetTableRecordsAddress(pcommodSdf, indexTable);
		g_tek_max = GetTableRecordsMax(pcommodSdf, indexTable);
	}

	indexTable = FindTable(pcommodSdf, "modtime");
	if(indexTable == -1)
		return commodError(hMutex);
	else{
		p_modtime = GetTableRecordsAddress(pcommodSdf, indexTable);
		modtime_max = GetTableRecordsMax(pcommodSdf, indexTable);
	}

	indexTable = FindTable(pcommodSdf, "All_nodes");
	if(indexTable == -1)
		return commodError(hMutex);
	else{
		p_All_nodes = GetTableRecordsAddress(pcommodSdf, indexTable);
		All_nodes_max = GetTableRecordsMax(pcommodSdf, indexTable);
	}

	indexTable = FindTable(pcommodSdf, "NameSch");
	if(indexTable == -1)
		return commodError(hMutex);
	else{
		p_NameSch = GetTableRecordsAddress(pcommodSdf, indexTable);
		NameSch_max = GetTableRecordsMax(pcommodSdf, indexTable);
	}

	indexTable = FindTable(pcommodSdf, "Upravl");
	if(indexTable == -1)
		return commodError(hMutex);
	else{
		p_Upravl = GetTableRecordsAddress(pcommodSdf, indexTable);
		Upravl_max = GetTableRecordsMax(pcommodSdf, indexTable);
	}

	indexTable = FindTable(pcommodSdf, "Upravl2");
	if(indexTable == -1)
		return commodError(hMutex);
	else{
		p_Upravl2 = GetTableRecordsAddress(pcommodSdf, indexTable);
		Upravl2_max = GetTableRecordsMax(pcommodSdf, indexTable);
	}

	indexTable = FindTable(pcommodSdf, "L_tek");
	if(indexTable == -1)
		return commodError(hMutex);
	else{
		p_L_tek = GetTableRecordsAddress(pcommodSdf, indexTable);
		L_tek_max = GetTableRecordsMax(pcommodSdf, indexTable);
	}

	indexTable = FindTable(pcommodSdf, "L_ts");
	if(indexTable == -1)
		return commodError(hMutex);
	else{
		p_L_ts = GetTableRecordsAddress(pcommodSdf, indexTable);
		L_ts_max = GetTableRecordsMax(pcommodSdf, indexTable);
	}

	offset = GetOffsetData(pcommodSdf, "rpn_id", &off);
	if(offset)
		rpn_id = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "rpn_name", &off);
	if(offset)
		rpn_name = (c100*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "rpn_Snom", &off);
	if(offset)
		rpn_Snom = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "rpn_UmaxNom", &off);
	if(offset)
		rpn_UmaxNom = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "rpn_UminNom", &off);
	if(offset)
		rpn_UminNom = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "rpn_H", &off);
	if(offset)
		rpn_H = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "rpn_Nanc", &off);
	if(offset)
		rpn_Nanc = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "rpn_NneutralAnc", &off);
	if(offset)
		rpn_NneutralAnc = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "rpn_DDopVn", &off);
	if(offset)
		rpn_DDopVn = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "rpn_DDopSn", &off);
	if(offset)
		rpn_DDopSn = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "rpn_DDopNn", &off);
	if(offset)
		rpn_DDopNn = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "rpn_arnt_p", &off);
	if(offset)
		rpn_arnt_p = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "A0", &off);
	if(offset)
		A0 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "A1", &off);
	if(offset)
		A1 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "A2", &off);
	if(offset)
		A2 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "AF", &off);
	if(offset)
		AF = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "B0", &off);
	if(offset)
		B0 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "B1", &off);
	if(offset)
		B1 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "B2", &off);
	if(offset)
		B2 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "BF", &off);
	if(offset)
		BF = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "IdLim", &off);
	if(offset)
		IdLim = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NameParamG", &off);
	if(offset)
		NameParamG = (c100*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "cosF", &off);
	if(offset)
		cosF = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "Qnom", &off);
	if(offset)
		Qnom = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "Xd", &off);
	if(offset)
		Xd = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "kI", &off);
	if(offset)
		kI = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "kE", &off);
	if(offset)
		kE = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "kP1", &off);
	if(offset)
		kP1 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "Q1", &off);
	if(offset)
		Q1 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "kP2", &off);
	if(offset)
		kP2 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "Q2", &off);
	if(offset)
		Q2 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "kP3", &off);
	if(offset)
		kP3 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "Q3", &off);
	if(offset)
		Q3 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "sec_Id", &off);
	if(offset)
		sec_Id = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "sec_name", &off);
	if(offset)
		sec_name = (c100*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "sec_ForDirName", &off);
	if(offset)
		sec_ForDirName = (c50*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "sec_RevDirName", &off);
	if(offset)
		sec_RevDirName = (c50*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "sec_flow", &off);
	if(offset)
		sec_flow = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "sec_ForLim", &off);
	if(offset)
		sec_ForLim = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "sec_RevLim", &off);
	if(offset)
		sec_RevLim = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "sec_flowR", &off);
	if(offset)
		sec_flowR = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "sec_lossA", &off);
	if(offset)
		sec_lossA = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "sec_lossR", &off);
	if(offset)
		sec_lossR = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "sec_nflow", &off);
	if(offset)
		sec_nflow = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "secmem_IdSec", &off);
	if(offset)
		secmem_IdSec = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "secmem_IdLine", &off);
	if(offset)
		secmem_IdLine = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "secmem_IdNode1", &off);
	if(offset)
		secmem_IdNode1 = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "secmem_IdNode2", &off);
	if(offset)
		secmem_IdNode2 = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "secmem_DiffPh", &off);
	if(offset)
		secmem_DiffPh = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "fcmp_k1", &off);
	if(offset)
		fcmp_k1 = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "fcmp_k2", &off);
	if(offset)
		fcmp_k2 = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "TechNumReg", &off);
	if(offset)
		TechNumReg = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NameRegions", &off);
	if(offset)
		NameRegions = (c50*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "RegGenAct", &off);
	if(offset)
		RegGenAct = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "RegGenRea", &off);
	if(offset)
		RegGenRea = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "RegLoadAct", &off);
	if(offset)
		RegLoadAct = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "RegLoadRea", &off);
	if(offset)
		RegLoadRea = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "RegSalAct", &off);
	if(offset)
		RegSalAct = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "RegSalRea", &off);
	if(offset)
		RegSalRea = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "USP", &off);
	if(offset)
		USP = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "VALS", &off);
	if(offset)
		VALS = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "KFR", &off);
	if(offset)
		KFR = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "FPRS", &off);
	if(offset)
		FPRS = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "FINS", &off);
	if(offset)
		FINS = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "PRMAX", &off);
	if(offset)
		PRMAX = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "PRMIN", &off);
	if(offset)
		PRMIN = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "QREG_MAX", &off);
	if(offset)
		QREG_MAX = (char*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "QREG_MIN", &off);
	if(offset)
		QREG_MIN = (char*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "PRSUM", &off);
	if(offset)
		PRSUM = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UCP", &off);
	if(offset)
		UCP = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "FCP", &off);
	if(offset)
		FCP = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UIN", &off);
	if(offset)
		UIN = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "op_ts_id", &off);
	if(offset)
		op_ts_id = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "op_ts_name", &off);
	if(offset)
		op_ts_name = (c50*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "op_ts_SubDispName", &off);
	if(offset)
		op_ts_SubDispName = (c30*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "op_ts_type", &off);
	if(offset)
		op_ts_type = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "op_ts_state", &off);
	if(offset)
		op_ts_state = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "op_ts_norm", &off);
	if(offset)
		op_ts_norm = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "op_ts_past", &off);
	if(offset)
		op_ts_past = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "op_ts_kvit", &off);
	if(offset)
		op_ts_kvit = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "op_ts_alarm", &off);
	if(offset)
		op_ts_alarm = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "op_ts_beg", &off);
	if(offset)
		op_ts_beg = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "op_ts_end", &off);
	if(offset)
		op_ts_end = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "corrected", &off);
	if(offset)
		corrected = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "op_ts_u1", &off);
	if(offset)
		op_ts_u1 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "op_ts_u2", &off);
	if(offset)
		op_ts_u2 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "op_ts_SubId", &off);
	if(offset)
		op_ts_SubId = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "op_ts_SubInd", &off);
	if(offset)
		op_ts_SubInd = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "rpnTab_id", &off);
	if(offset)
		rpnTab_id = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "ANC1", &off);
	if(offset)
		ANC1 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "ANC2", &off);
	if(offset)
		ANC2 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "ANC3", &off);
	if(offset)
		ANC3 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "ANC4", &off);
	if(offset)
		ANC4 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "ANC5", &off);
	if(offset)
		ANC5 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "ANC6", &off);
	if(offset)
		ANC6 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "ANC7", &off);
	if(offset)
		ANC7 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "ANC8", &off);
	if(offset)
		ANC8 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "ANC9", &off);
	if(offset)
		ANC9 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "ANC10", &off);
	if(offset)
		ANC10 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "ANC11", &off);
	if(offset)
		ANC11 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "ANC12", &off);
	if(offset)
		ANC12 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "ANC13", &off);
	if(offset)
		ANC13 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "ANC14", &off);
	if(offset)
		ANC14 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "ANC15", &off);
	if(offset)
		ANC15 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "ANC16", &off);
	if(offset)
		ANC16 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "ANC17", &off);
	if(offset)
		ANC17 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "ANC18", &off);
	if(offset)
		ANC18 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "ANC19", &off);
	if(offset)
		ANC19 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "ANC20", &off);
	if(offset)
		ANC20 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "trans_id", &off);
	if(offset)
		trans_id = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "trans_SubId", &off);
	if(offset)
		trans_SubId = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "trans_line1", &off);
	if(offset)
		trans_line1 = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "trans_line2", &off);
	if(offset)
		trans_line2 = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "trans_line3", &off);
	if(offset)
		trans_line3 = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "trans_per1", &off);
	if(offset)
		trans_per1 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "trans_per2", &off);
	if(offset)
		trans_per2 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "trans_per3", &off);
	if(offset)
		trans_per3 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "trans_peq1", &off);
	if(offset)
		trans_peq1 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "trans_peq2", &off);
	if(offset)
		trans_peq2 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "trans_peq3", &off);
	if(offset)
		trans_peq3 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "trans_tok1", &off);
	if(offset)
		trans_tok1 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "trans_tok2", &off);
	if(offset)
		trans_tok2 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "trans_tok3", &off);
	if(offset)
		trans_tok3 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "sign_CDU", &off);
	if(offset)
		sign_CDU = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "FileName_CDU", &off);
	if(offset)
		FileName_CDU = (c255*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "fTime_CDU", &off);
	if(offset)
		fTime_CDU = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "LoadOnce", &off);
	if(offset)
		LoadOnce = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "blocks_nug", &off);
	if(offset)
		blocks_nug = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "blocks_num", &off);
	if(offset)
		blocks_num = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "blocks_ts1", &off);
	if(offset)
		blocks_ts1 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "blocks_ts2", &off);
	if(offset)
		blocks_ts2 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "blocks_ts3", &off);
	if(offset)
		blocks_ts3 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "blocks_ts4", &off);
	if(offset)
		blocks_ts4 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "blocks_ts5", &off);
	if(offset)
		blocks_ts5 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "blocks_ts6", &off);
	if(offset)
		blocks_ts6 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "blocks_ts7", &off);
	if(offset)
		blocks_ts7 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "blocks_ts8", &off);
	if(offset)
		blocks_ts8 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "blocks_connect_type", &off);
	if(offset)
		blocks_connect_type = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "blocks_state", &off);
	if(offset)
		blocks_state = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "blocks_gen", &off);
	if(offset)
		blocks_gen = (double*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "shunts_nod", &off);
	if(offset)
		shunts_nod = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "shunts_num", &off);
	if(offset)
		shunts_num = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "shunts_ts1", &off);
	if(offset)
		shunts_ts1 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "shunts_ts2", &off);
	if(offset)
		shunts_ts2 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "shunts_ts3", &off);
	if(offset)
		shunts_ts3 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "shunts_ts4", &off);
	if(offset)
		shunts_ts4 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "shunts_ts5", &off);
	if(offset)
		shunts_ts5 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "shunts_ts6", &off);
	if(offset)
		shunts_ts6 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "shunts_ts7", &off);
	if(offset)
		shunts_ts7 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "shunts_ts8", &off);
	if(offset)
		shunts_ts8 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "shunts_connect_type", &off);
	if(offset)
		shunts_connect_type = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "shunts_state", &off);
	if(offset)
		shunts_state = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UNOB1", &off);
	if(offset)
		UNOB1 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UNOB2", &off);
	if(offset)
		UNOB2 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UNOB3", &off);
	if(offset)
		UNOB3 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UNOB4", &off);
	if(offset)
		UNOB4 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UNOB5", &off);
	if(offset)
		UNOB5 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UNOB6", &off);
	if(offset)
		UNOB6 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UNOB7", &off);
	if(offset)
		UNOB7 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UNOB8", &off);
	if(offset)
		UNOB8 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UKZ0", &off);
	if(offset)
		UKZ0 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UKZ1", &off);
	if(offset)
		UKZ1 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UKZ4", &off);
	if(offset)
		UKZ4 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UKZ5", &off);
	if(offset)
		UKZ5 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NOB1", &off);
	if(offset)
		NOB1 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NOB2", &off);
	if(offset)
		NOB2 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NOB3", &off);
	if(offset)
		NOB3 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "TKZ0", &off);
	if(offset)
		TKZ0 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "TKZ1", &off);
	if(offset)
		TKZ1 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "TKZ2", &off);
	if(offset)
		TKZ2 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "TKZ3", &off);
	if(offset)
		TKZ3 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "TKZ4", &off);
	if(offset)
		TKZ4 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "TKZ5", &off);
	if(offset)
		TKZ5 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "TKZ6", &off);
	if(offset)
		TKZ6 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "TKZ7", &off);
	if(offset)
		TKZ7 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NON", &off);
	if(offset)
		NON = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NAN", &off);
	if(offset)
		NAN = (c30*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "DOL", &off);
	if(offset)
		DOL = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UN", &off);
	if(offset)
		UN = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "FAN", &off);
	if(offset)
		FAN = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "FN", &off);
	if(offset)
		FN = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "BLC", &off);
	if(offset)
		BLC = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "PNA", &off);
	if(offset)
		PNA = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "BLR", &off);
	if(offset)
		BLR = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "PNQ", &off);
	if(offset)
		PNQ = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "TUN", &off);
	if(offset)
		TUN = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "KSN", &off);
	if(offset)
		KSN = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "SNAS", &off);
	if(offset)
		SNAS = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "SNRS", &off);
	if(offset)
		SNRS = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "SNA", &off);
	if(offset)
		SNA = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "SNR", &off);
	if(offset)
		SNR = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "QBL", &off);
	if(offset)
		QBL = (char*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "REN", &off);
	if(offset)
		REN = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "DAD", &off);
	if(offset)
		DAD = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "PON", &off);
	if(offset)
		PON = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NRN", &off);
	if(offset)
		NRN = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NRN_TR", &off);
	if(offset)
		NRN_TR = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NL_InjectionP", &off);
	if(offset)
		NL_InjectionP = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NL_InjectionQ", &off);
	if(offset)
		NL_InjectionQ = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "QSN", &off);
	if(offset)
		QSN = (char*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "QFRN", &off);
	if(offset)
		QFRN = (char*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "TDA", &off);
	if(offset)
		TDA = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "SAD", &off);
	if(offset)
		SAD = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "QAD", &off);
	if(offset)
		QAD = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "RMAD", &off);
	if(offset)
		RMAD = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "PAD", &off);
	if(offset)
		PAD = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "FAD", &off);
	if(offset)
		FAD = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UIZ", &off);
	if(offset)
		UIZ = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "BKRN", &off);
	if(offset)
		BKRN = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NL_UPMax", &off);
	if(offset)
		NL_UPMax = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NL_UPMin", &off);
	if(offset)
		NL_UPMin = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NL_UAMax", &off);
	if(offset)
		NL_UAMax = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NL_UAMin", &off);
	if(offset)
		NL_UAMin = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "EMAL", &off);
	if(offset)
		EMAL = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "MMAL", &off);
	if(offset)
		MMAL = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "SiAD", &off);
	if(offset)
		SiAD = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NUG", &off);
	if(offset)
		NUG = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NAG", &off);
	if(offset)
		NAG = (c30*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UU", &off);
	if(offset)
		UU = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "FAZA", &off);
	if(offset)
		FAZA = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "F", &off);
	if(offset)
		F = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "SAL", &off);
	if(offset)
		SAL = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "AK", &off);
	if(offset)
		AK = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "AKI", &off);
	if(offset)
		AKI = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "PAG", &off);
	if(offset)
		PAG = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "BAG", &off);
	if(offset)
		BAG = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UGN", &off);
	if(offset)
		UGN = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UMAX", &off);
	if(offset)
		UMAX = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UMIN", &off);
	if(offset)
		UMIN = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "DUG", &off);
	if(offset)
		DUG = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "FUG", &off);
	if(offset)
		FUG = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "PQG", &off);
	if(offset)
		PQG = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "QKS", &off);
	if(offset)
		QKS = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "KSG", &off);
	if(offset)
		KSG = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "SGAS", &off);
	if(offset)
		SGAS = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "SGRS", &off);
	if(offset)
		SGRS = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "SGA", &off);
	if(offset)
		SGA = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "SGR", &off);
	if(offset)
		SGR = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UUR", &off);
	if(offset)
		UUR = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UUS", &off);
	if(offset)
		UUS = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UF", &off);
	if(offset)
		UF = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UO", &off);
	if(offset)
		UO = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "QSG", &off);
	if(offset)
		QSG = (char*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NTIG", &off);
	if(offset)
		NTIG = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "REG_REG", &off);
	if(offset)
		REG_REG = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "REG_REG_TR", &off);
	if(offset)
		REG_REG_TR = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "QGN", &off);
	if(offset)
		QGN = (char*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "APBN", &off);
	if(offset)
		APBN = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "APB", &off);
	if(offset)
		APB = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NG_InjectionP", &off);
	if(offset)
		NG_InjectionP = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NG_InjectionQ", &off);
	if(offset)
		NG_InjectionQ = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "TUG", &off);
	if(offset)
		TUG = (char*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "QFRG", &off);
	if(offset)
		QFRG = (char*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "QMAX", &off);
	if(offset)
		QMAX = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "QMIN", &off);
	if(offset)
		QMIN = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "PMIN", &off);
	if(offset)
		PMIN = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "PMAX", &off);
	if(offset)
		PMAX = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "PAFR", &off);
	if(offset)
		PAFR = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "KBL", &off);
	if(offset)
		KBL = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "KBLN", &off);
	if(offset)
		KBLN = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "TDD", &off);
	if(offset)
		TDD = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NDT", &off);
	if(offset)
		NDT = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NDG", &off);
	if(offset)
		NDG = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "BKBG", &off);
	if(offset)
		BKBG = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "BKBN", &off);
	if(offset)
		BKBN = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "BKRG", &off);
	if(offset)
		BKRG = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "PRICE", &off);
	if(offset)
		PRICE = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "REA", &off);
	if(offset)
		REA = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UG1", &off);
	if(offset)
		UG1 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "G0", &off);
	if(offset)
		G0 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "G1", &off);
	if(offset)
		G1 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "G2", &off);
	if(offset)
		G2 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "G3", &off);
	if(offset)
		G3 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "uff", &off);
	if(offset)
		uff = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "uqp", &off);
	if(offset)
		uqp = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "uup", &off);
	if(offset)
		uup = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "ft", &off);
	if(offset)
		ft = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "fg", &off);
	if(offset)
		fg = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "fa", &off);
	if(offset)
		fa = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "ff", &off);
	if(offset)
		ff = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "BQG", &off);
	if(offset)
		BQG = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "PDD", &off);
	if(offset)
		PDD = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "SV", &off);
	if(offset)
		SV = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UGP", &off);
	if(offset)
		UGP = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "DUR", &off);
	if(offset)
		DUR = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "AKF", &off);
	if(offset)
		AKF = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "AKP", &off);
	if(offset)
		AKP = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "X_NODE", &off);
	if(offset)
		X_NODE = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "Y_NODE", &off);
	if(offset)
		Y_NODE = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NG_UPMax", &off);
	if(offset)
		NG_UPMax = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NG_UPMin", &off);
	if(offset)
		NG_UPMin = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NG_UAMax", &off);
	if(offset)
		NG_UAMax = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NG_UAMin", &off);
	if(offset)
		NG_UAMin = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NG_PPMax", &off);
	if(offset)
		NG_PPMax = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NG_PPMin", &off);
	if(offset)
		NG_PPMin = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NG_PAMax", &off);
	if(offset)
		NG_PAMax = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NG_PAMin", &off);
	if(offset)
		NG_PAMin = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "SubId", &off);
	if(offset)
		SubId = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "KoefCor", &off);
	if(offset)
		KoefCor = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "GDEAD", &off);
	if(offset)
		GDEAD = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "Pbal", &off);
	if(offset)
		Pbal = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "Qbal", &off);
	if(offset)
		Qbal = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "typeLimQ", &off);
	if(offset)
		typeLimQ = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "AKM", &off);
	if(offset)
		AKM = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "ADIN", &off);
	if(offset)
		ADIN = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "AKTEK", &off);
	if(offset)
		AKTEK = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "bnp", &off);
	if(offset)
		bnp = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "bb", &off);
	if(offset)
		bb = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "g_IsTrans", &off);
	if(offset)
		g_IsTrans = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NFU", &off);
	if(offset)
		NFU = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UUC", &off);
	if(offset)
		UUC = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "timeM", &off);
	if(offset)
		timeM = (double*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "MaxdtCounter", &off);
	if(offset)
		MaxdtCounter = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "DT", &off);
	if(offset)
		DT = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NGN", &off);
	if(offset)
		NGN = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NAGN", &off);
	if(offset)
		NAGN = (c30*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "RND", &off);
	if(offset)
		RND = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "SS", &off);
	if(offset)
		SS = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "SAR", &off);
	if(offset)
		SAR = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "SAQ", &off);
	if(offset)
		SAQ = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "EMU", &off);
	if(offset)
		EMU = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "RMU", &off);
	if(offset)
		RMU = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "FANP", &off);
	if(offset)
		FANP = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UUGN", &off);
	if(offset)
		UUGN = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "UGNA", &off);
	if(offset)
		UGNA = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "FFGN", &off);
	if(offset)
		FFGN = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "AllRegNodes", &off);
	if(offset)
		AllRegNodes = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "FLAG_NODE", &off);
	if(offset)
		FLAG_NODE = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "X_sh", &off);
	if(offset)
		X_sh = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "Y_sh", &off);
	if(offset)
		Y_sh = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "DEAD", &off);
	if(offset)
		DEAD = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "RND_UUGN", &off);
	if(offset)
		RND_UUGN = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "RND_FANP", &off);
	if(offset)
		RND_FANP = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "GRN", &off);
	if(offset)
		GRN = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "X_sh1", &off);
	if(offset)
		X_sh1 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "Y_sh1", &off);
	if(offset)
		Y_sh1 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NAME", &off);
	if(offset)
		NAME = (c50*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "Comment", &off);
	if(offset)
		Comment = (c128*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "File_schm", &off);
	if(offset)
		File_schm = (c128*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "SupportNodeTech", &off);
	if(offset)
		SupportNodeTech = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NU", &off);
	if(offset)
		NU = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "MM", &off);
	if(offset)
		MM = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "N1", &off);
	if(offset)
		N1 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "SZ", &off);
	if(offset)
		SZ = (char*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "SZINT", &off);
	if(offset)
		SZINT = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "SZFLOAT", &off);
	if(offset)
		SZFLOAT = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "AfterLoadPause", &off);
	if(offset)
		AfterLoadPause = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "BaseNug", &off);
	if(offset)
		BaseNug = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "FreqInBase", &off);
	if(offset)
		FreqInBase = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "Lnum", &off);
	if(offset)
		Lnum = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "KG_ind", &off);
	if(offset)
		KG_ind = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "KL_ind", &off);
	if(offset)
		KL_ind = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "KG_ish", &off);
	if(offset)
		KG_ish = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "KL_ish", &off);
	if(offset)
		KL_ish = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NAL", &off);
	if(offset)
		NAL = (c12*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "LType", &off);
	if(offset)
		LType = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NLI", &off);
	if(offset)
		NLI = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NRL", &off);
	if(offset)
		NRL = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "PER", &off);
	if(offset)
		PER = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "PER1", &off);
	if(offset)
		PER1 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "PER2", &off);
	if(offset)
		PER2 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "POT", &off);
	if(offset)
		POT = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "PEQ", &off);
	if(offset)
		PEQ = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "PEQ1", &off);
	if(offset)
		PEQ1 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "PEQ2", &off);
	if(offset)
		PEQ2 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "PQT", &off);
	if(offset)
		PQT = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "TOK1", &off);
	if(offset)
		TOK1 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "TOK_START", &off);
	if(offset)
		TOK_START = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "TOK_END", &off);
	if(offset)
		TOK_END = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "TRA", &off);
	if(offset)
		TRA = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "TRK", &off);
	if(offset)
		TRK = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "TRKM", &off);
	if(offset)
		TRKM = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "BKL", &off);
	if(offset)
		BKL = (char*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "BKL1", &off);
	if(offset)
		BKL1 = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "BKL2", &off);
	if(offset)
		BKL2 = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "LCH1", &off);
	if(offset)
		LCH1 = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "LCH2", &off);
	if(offset)
		LCH2 = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "QDA", &off);
	if(offset)
		QDA = (char*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "QON", &off);
	if(offset)
		QON = (char*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "OL", &off);
	if(offset)
		OL = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "SIR", &off);
	if(offset)
		SIR = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "SIG", &off);
	if(offset)
		SIG = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "EMK", &off);
	if(offset)
		EMK = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "KORON", &off);
	if(offset)
		KORON = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NFL", &off);
	if(offset)
		NFL = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "QFL", &off);
	if(offset)
		QFL = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NFQ", &off);
	if(offset)
		NFQ = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "BFL", &off);
	if(offset)
		BFL = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NTIL", &off);
	if(offset)
		NTIL = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "PRL", &off);
	if(offset)
		PRL = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "LnumD", &off);
	if(offset)
		LnumD = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_PPMax", &off);
	if(offset)
		L_PPMax = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_PPMin", &off);
	if(offset)
		L_PPMin = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_PAMax", &off);
	if(offset)
		L_PAMax = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_PAMin", &off);
	if(offset)
		L_PAMin = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_IPMax", &off);
	if(offset)
		L_IPMax = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_IPMin", &off);
	if(offset)
		L_IPMin = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_IAMax", &off);
	if(offset)
		L_IAMax = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_IAMin", &off);
	if(offset)
		L_IAMin = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "U_start", &off);
	if(offset)
		U_start = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "U_end", &off);
	if(offset)
		U_end = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NALF", &off);
	if(offset)
		NALF = (c100*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "INVAL", &off);
	if(offset)
		INVAL = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "RND_PER1", &off);
	if(offset)
		RND_PER1 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "RND_PER2", &off);
	if(offset)
		RND_PER2 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "RND_PEQ1", &off);
	if(offset)
		RND_PEQ1 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "RND_PEQ2", &off);
	if(offset)
		RND_PEQ2 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "RND_TOK1", &off);
	if(offset)
		RND_TOK1 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "RND_FAZA_TOK1", &off);
	if(offset)
		RND_FAZA_TOK1 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "RND_TOK2", &off);
	if(offset)
		RND_TOK2 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "RND_FAZA_TOK2", &off);
	if(offset)
		RND_FAZA_TOK2 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_SubId1", &off);
	if(offset)
		L_SubId1 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_SubId2", &off);
	if(offset)
		L_SubId2 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "NomAnc", &off);
	if(offset)
		NomAnc = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "LGRN1", &off);
	if(offset)
		LGRN1 = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "LGRN2", &off);
	if(offset)
		LGRN2 = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "LDEAD1", &off);
	if(offset)
		LDEAD1 = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "LDEAD2", &off);
	if(offset)
		LDEAD2 = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_unom1", &off);
	if(offset)
		L_unom1 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_unom2", &off);
	if(offset)
		L_unom2 = (float*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_istrans", &off);
	if(offset)
		L_istrans = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_ts_Begin1", &off);
	if(offset)
		L_ts_Begin1 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_ts_Begin2", &off);
	if(offset)
		L_ts_Begin2 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_ts_Begin3", &off);
	if(offset)
		L_ts_Begin3 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_ts_Begin4", &off);
	if(offset)
		L_ts_Begin4 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_ts_Begin5", &off);
	if(offset)
		L_ts_Begin5 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_ts_Begin6", &off);
	if(offset)
		L_ts_Begin6 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_ts_Begin7", &off);
	if(offset)
		L_ts_Begin7 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_ts_Begin8", &off);
	if(offset)
		L_ts_Begin8 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_ts_End1", &off);
	if(offset)
		L_ts_End1 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_ts_End2", &off);
	if(offset)
		L_ts_End2 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_ts_End3", &off);
	if(offset)
		L_ts_End3 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_ts_End4", &off);
	if(offset)
		L_ts_End4 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_ts_End5", &off);
	if(offset)
		L_ts_End5 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_ts_End6", &off);
	if(offset)
		L_ts_End6 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_ts_End7", &off);
	if(offset)
		L_ts_End7 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_ts_End8", &off);
	if(offset)
		L_ts_End8 = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_ts_begin", &off);
	if(offset)
		L_ts_begin = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_ts_end", &off);
	if(offset)
		L_ts_end = (int*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_ts_paralel", &off);
	if(offset)
		L_ts_paralel = (short*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_ts_type_begin", &off);
	if(offset)
		L_ts_type_begin = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	offset = GetOffsetData(pcommodSdf, "L_ts_type_end", &off);
	if(offset)
		L_ts_type_end = (BYTE*)(pBase + off);
	else
		return commodError(hMutex);

	ReleaseMutex(hMutex);
	CloseHandle(hMutex);

	return result;
}

void commodClose()
{
	HANDLE hMutex = 0;
	hMutex = CreateMutexA(NULL, FALSE, "__commod_mutex");
	WaitForSingleObject(hMutex, INFINITE);

	if(pcommodSdf != NULL)
	{
		DeleteInfoSdf(&pcommodSdf);
		pcommodSdf = NULL;
	}

	if(commodBuf)
	{
		UnmapViewOfFile(commodBuf);
		commodBuf = NULL;
	}

	if(commodMap)
	{
		CloseHandle(commodMap);
		commodMap = NULL;
	}

	ReleaseMutex(hMutex);
	CloseHandle(hMutex);
}
