/*******************************************************************/
/* cpp-   Tabula     */
/*  : z:\casfsk\oik.sdf                                     */
/*******************************************************************/

#include "stdafx.h"
#include <stdio.h>
#include <malloc.h>
#include "oiksdf.h"

//    
//: pBuf -   , nPos -   , data -   , size - 
static void ReadBuf(const char* pBuf, int *nPos, void* data, int size)
{
	memcpy(data, pBuf+(*nPos), size);
	(*nPos) += size;	
}

//    
//: pBuf -   , nPos -   , _ch -   
static void ReadStrBuf(const char* pBuf, int *nPos, char* _ch)
{
	WORD len;
	ReadBuf(pBuf, nPos, &len, sizeof(len));
	ReadBuf(pBuf, nPos, _ch, len);
}

//        
static void GetInfoAboutSdf(const char* p_tBuf, struct sTable** pTable)
{
	int		m_nPos	= 0;
	WORD	nCountT	= 0;
	WORD	iT		= 0;
	WORD	iF		= 0;
	BYTE	byrec	= 0;
	DWORD	tPos	= 0; 
	DWORD	off		= 0;
	BYTE	version = 0;
	DWORD	currentRecord = 0;
	
 	ReadBuf(p_tBuf, &m_nPos, &nCountT, sizeof(WORD));
	version = HIBYTE(nCountT);
	if(version != 0){
		ReadBuf(p_tBuf, &m_nPos, &nCountT, sizeof(WORD));
	}

	(*pTable) = (struct sTable*)calloc(nCountT, sizeof(struct sTable));
	
	for(iT = 0; iT < nCountT; iT++){

		(*pTable)[iT].off = m_nPos;

		ReadStrBuf(p_tBuf, &m_nPos, (*pTable)[iT].name);
		ReadBuf(p_tBuf, &m_nPos, &(*pTable)[iT].nCountR, sizeof(DWORD));		

		//    1      ,
		//     
		if(version != 0){
			(*pTable)[iT].p_CurRecord = (DWORD*)&p_tBuf[m_nPos];
			ReadBuf(p_tBuf, &m_nPos, &currentRecord, sizeof(DWORD));
		}

		ReadBuf(p_tBuf, &m_nPos, &(*pTable)[iT].nCountF, sizeof(WORD));
		
		(*pTable)[iT].infoField = (struct sField*)calloc((*pTable)[iT].nCountF, sizeof(struct sField));

		for(iF = 0; iF < (*pTable)[iT].nCountF; iF++){

			(*pTable)[iT].infoField[iF].off = m_nPos;
			ReadStrBuf(p_tBuf, &m_nPos, (*pTable)[iT].infoField[iF].name);
			ReadBuf(p_tBuf, &m_nPos, &(*pTable)[iT].infoField[iF].type, sizeof(WORD));
			ReadBuf(p_tBuf, &m_nPos, &byrec, sizeof(BYTE));

		}

		byrec = 0;		
		ReadBuf(p_tBuf, &m_nPos, &byrec, sizeof(BYTE));

		tPos = m_nPos;
		(*pTable)[iT].offData = m_nPos;

		if(byrec){ // 

			for(iF=0, off=0; iF < (*pTable)[iT].nCountF; iF++){

				(*pTable)[iT].infoField[iF].offData = tPos;
				off += TYPESIZE((*pTable)[iT].infoField[iF].type);

			}

			(*pTable)[iT].SizeOfFields = off;
			m_nPos = tPos + off*(*pTable)[iT].nCountR;

		}

		else{

			for(iF = 0, off = tPos; iF < (*pTable)[iT].nCountF; iF++){

				(*pTable)[iT].infoField[iF].offData = off;
				off += TYPESIZE((*pTable)[iT].infoField[iF].type)*(*pTable)[iT].nCountR;

			}

			m_nPos = off;
			(*pTable)[iT].SizeOfFields = off - tPos;

		}
	}
}

//      
static BYTE GetOffsetDataByRec(const struct sTable* pTable, DWORD index, DWORD* off)
{
	size_t size = _msize((struct sTable*)pTable) / sizeof(struct sTable);
	
	if(index >= 0 && index < size && pTable[index].nCountF > 0)
	{
		(*off) = pTable[index].infoField[0].offData;
		return (BYTE)1;
	}
	else
		return 0;
	
}

//  
static BYTE GetOffsetData(const struct sTable* pTable, const char* field, DWORD* off)
{
	size_t	size		= _msize((struct sTable*)pTable)/sizeof(struct sTable);
	DWORD	iT			= 0;
	WORD	iF			= 0;
	char	_ch1		= '\\';
	BYTE	find_ch1	= 0;
	char	_ch2		= '.';
	BYTE find_ch2		= 0;
	char *res1			= 0;
	char *res2			= 0;
	char *pdest			= 0;
	int len				= -1;

	for(iT = 0; iT < size; iT++){

		for(iF = 0; iF < pTable[iT].nCountF; iF++){

			pdest = strchr(pTable[iT].infoField[iF].name, _ch1);
			if(pdest!=NULL){
				len = pdest - pTable[iT].infoField[iF].name;
				find_ch1 = 1;
				res1 = (char*)calloc((size_t)len + 1, sizeof(char));
				memcpy(res1, pTable[iT].infoField[iF].name, (size_t)len);
				res1[len] = '\0';
			}

			len = -1;
			pdest = strchr(res1, _ch2);
			if(pdest!=NULL){
				len = pdest - res1;
				find_ch2 = 1;
				res2 = (char*)calloc(len + 1, sizeof(char));
				memcpy(res2, res1, len);
				res2[len] = '\0';
			}

			if(find_ch2 && find_ch1){
				if (strcmp(field, res2) == 0){

					(*off) = pTable[iT].infoField[iF].offData;

					free((void*)res2); free((void*)res1);
					return (BYTE)1;
				}
			}

			else if(find_ch1 && !find_ch2){
				if (strcmp(field, res1) == 0){
					(*off) = pTable[iT].infoField[iF].offData;
					free((void*)res1);
					return (BYTE)1;
				}
			}
			
			if(find_ch1) 
				free((void*)res1);

			find_ch1 = 0;

			if(find_ch2) 
				free((void*)res2);

			find_ch2 = 0;
		}
		
	}

	return (BYTE)0;
}

//   
static int FindTable(const struct sTable *pTable, const char *szTableName)
{
	size_t size = _msize((struct sTable*)pTable) / sizeof(struct sTable);
	
	DWORD iT = 0;
	for(/*iT = 0*/; iT < size; iT++){
		
		if(strncmp(pTable[iT].name, szTableName, strlen(szTableName)) == 0)
			return (int)iT;
		
	}
	
	return -1;

}

//     - 
static DWORD* GetTableRecordsAddress(const struct sTable *pTable, DWORD index)
{
	size_t size = _msize((struct sTable*)pTable) / sizeof(struct sTable);
	
	if(index >= 0 && index < size)
		return pTable[index].p_CurRecord;
	else
		return 0;
}

//    - 
static DWORD GetTableRecordsMax(const struct sTable *pTable, DWORD index)
{
	size_t size = _msize((struct sTable*)pTable) / sizeof(struct sTable);
	
	if(index >= 0 && index < size)
		return pTable[index].nCountR;
	else
		return 0;
}

//  
static void DeleteInfoSdf(struct sTable** pTable)
{
	size_t size	= 0;
	DWORD iT	= 0;
	
	size = _msize((*pTable))/sizeof(struct sTable);

	for(iT = 0; iT < size; iT++)
 		free((*pTable)[iT].infoField);		

	if(size)
  		free((*pTable));
}

//     ti
DWORD ti_max = 0;
DWORD *p_ti = NULL;
int    *tiObj;
int    *tiId;
c64    *tiName;
double *tiVal;
int    *tiStatus;
int    *tiTime;
BYTE   *tiType;
int    *tiSrc;

//     ts
DWORD ts_max = 0;
DWORD *p_ts = NULL;
int    *tsObj;
int    *tsId;
c64    *tsName;
BYTE   *tsVal;
int    *tsStatus;
int    *tsTime;
int    *tsSrc;

//   
int oiksdfError(HANDLE hMutex)
{
	p_ti = NULL;
	p_ts = NULL;

	ti_max = 0;
	ts_max = 0;

	tiObj = NULL;
	tiId = NULL;
	tiName = NULL;
	tiVal = NULL;
	tiStatus = NULL;
	tiTime = NULL;
	tiType = NULL;
	tiSrc = NULL;
	tsObj = NULL;
	tsId = NULL;
	tsName = NULL;
	tsVal = NULL;
	tsStatus = NULL;
	tsTime = NULL;
	tsSrc = NULL;

	ReleaseMutex(hMutex);
	CloseHandle(hMutex);

	return 0;
}

LPVOID oiksdfBuf = NULL;
HANDLE oiksdfMap = NULL;

struct sTable *poiksdfSdf = NULL;

int oiksdfOpen(const char* name)
{
	DWORD off = 0;
	BYTE offset = 0;
	int result = 0;
	char *p = 0;
	char *pBase = 0;
	char fname[MAX_PATH] = {0};
	char mname[MAX_PATH] = {0};
	HANDLE hMutex     = 0;
	HANDLE hFile      = 0;
	DWORD  sizeFile   = 0;
	int   indexTable = -1;

	if(name == NULL)
		strcpy(fname, "oik.sdf");
	else
		strcpy(fname, (const char*)name);

	if(strchr(fname, ':') == NULL){
		char dir[MAX_PATH] = {0};
		GetModuleFileNameA(NULL, dir, sizeof(dir));
		*(strrchr(dir, '\\') + 1) = '\0';
		strcat(dir, fname);
		strcpy(fname,dir);
	}

	GetFullPathNameA(fname, sizeof(mname), mname, &p);
	//GetLongPathName(fname, mname, sizeof(mname));
	_strlwr(mname);

	p=mname;
	while(*p){
		if(*p<'0') *p= '_';
		if(*p>'9' && *p<'A') *p= '_';
		if(*p>'z') *p= '_';
		if(*p>'Z' && *p<'a') *p= '_';
		p++;
	}

	hMutex = CreateMutexA(NULL, FALSE, "__oiksdf_mutex");

	WaitForSingleObject(hMutex, INFINITE);

	oiksdfMap = OpenFileMappingA(FILE_MAP_ALL_ACCESS, FALSE, mname);

	if(oiksdfMap == NULL){

		hFile = CreateFileA(fname, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
		if(hFile == INVALID_HANDLE_VALUE)
			return oiksdfError(hMutex);

		sizeFile = GetFileSize(hFile, NULL);

		oiksdfMap = CreateFileMappingA(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, sizeFile, mname);
		if(oiksdfMap == NULL)
			return oiksdfError(hMutex);

		oiksdfBuf = MapViewOfFile(oiksdfMap, FILE_MAP_ALL_ACCESS, 0, 0, 0);
		if(oiksdfBuf == NULL)
			return oiksdfError(hMutex);

		if(!ReadFile(hFile, oiksdfBuf, sizeFile, &sizeFile, NULL))
			return oiksdfError(hMutex);

		CloseHandle(hFile);

		result = 2;

	}
	else{

		oiksdfBuf = MapViewOfFile(oiksdfMap, FILE_MAP_ALL_ACCESS, 0, 0, 0);
		if(oiksdfBuf == NULL)
			return oiksdfError(hMutex);

		result = 1;
	}

	pBase = (char*)oiksdfBuf;

	GetInfoAboutSdf(pBase, &poiksdfSdf);

	indexTable = FindTable(poiksdfSdf, "ti");
	if(indexTable == -1)
		return oiksdfError(hMutex);
	else{
		p_ti = GetTableRecordsAddress(poiksdfSdf, indexTable);
		ti_max = GetTableRecordsMax(poiksdfSdf, indexTable);
	}

	indexTable = FindTable(poiksdfSdf, "ts");
	if(indexTable == -1)
		return oiksdfError(hMutex);
	else{
		p_ts = GetTableRecordsAddress(poiksdfSdf, indexTable);
		ts_max = GetTableRecordsMax(poiksdfSdf, indexTable);
	}

	offset = GetOffsetData(poiksdfSdf, "tiObj", &off);
	if(offset)
		tiObj = (int*)(pBase + off);
	else
		return oiksdfError(hMutex);

	offset = GetOffsetData(poiksdfSdf, "tiId", &off);
	if(offset)
		tiId = (int*)(pBase + off);
	else
		return oiksdfError(hMutex);

	offset = GetOffsetData(poiksdfSdf, "tiName", &off);
	if(offset)
		tiName = (c64*)(pBase + off);
	else
		return oiksdfError(hMutex);

	offset = GetOffsetData(poiksdfSdf, "tiVal", &off);
	if(offset)
		tiVal = (double*)(pBase + off);
	else
		return oiksdfError(hMutex);

	offset = GetOffsetData(poiksdfSdf, "tiStatus", &off);
	if(offset)
		tiStatus = (int*)(pBase + off);
	else
		return oiksdfError(hMutex);

	offset = GetOffsetData(poiksdfSdf, "tiTime", &off);
	if(offset)
		tiTime = (int*)(pBase + off);
	else
		return oiksdfError(hMutex);

	offset = GetOffsetData(poiksdfSdf, "tiType", &off);
	if(offset)
		tiType = (BYTE*)(pBase + off);
	else
		return oiksdfError(hMutex);

	offset = GetOffsetData(poiksdfSdf, "tiSrc", &off);
	if(offset)
		tiSrc = (int*)(pBase + off);
	else
		return oiksdfError(hMutex);

	offset = GetOffsetData(poiksdfSdf, "tsObj", &off);
	if(offset)
		tsObj = (int*)(pBase + off);
	else
		return oiksdfError(hMutex);

	offset = GetOffsetData(poiksdfSdf, "tsId", &off);
	if(offset)
		tsId = (int*)(pBase + off);
	else
		return oiksdfError(hMutex);

	offset = GetOffsetData(poiksdfSdf, "tsName", &off);
	if(offset)
		tsName = (c64*)(pBase + off);
	else
		return oiksdfError(hMutex);

	offset = GetOffsetData(poiksdfSdf, "tsVal", &off);
	if(offset)
		tsVal = (BYTE*)(pBase + off);
	else
		return oiksdfError(hMutex);

	offset = GetOffsetData(poiksdfSdf, "tsStatus", &off);
	if(offset)
		tsStatus = (int*)(pBase + off);
	else
		return oiksdfError(hMutex);

	offset = GetOffsetData(poiksdfSdf, "tsTime", &off);
	if(offset)
		tsTime = (int*)(pBase + off);
	else
		return oiksdfError(hMutex);

	offset = GetOffsetData(poiksdfSdf, "tsSrc", &off);
	if(offset)
		tsSrc = (int*)(pBase + off);
	else
		return oiksdfError(hMutex);

	ReleaseMutex(hMutex);
	CloseHandle(hMutex);

	return result;
}

void oiksdfClose()
{
	HANDLE hMutex = 0;
	hMutex = CreateMutexA(NULL, FALSE, "__oiksdf_mutex");
	WaitForSingleObject(hMutex, INFINITE);

	if(poiksdfSdf != NULL)
	{
		DeleteInfoSdf(&poiksdfSdf);
		poiksdfSdf = NULL;
	}

	if(oiksdfBuf)
	{
		UnmapViewOfFile(oiksdfBuf);
		oiksdfBuf = NULL;
	}

	if(oiksdfMap)
	{
		CloseHandle(oiksdfMap);
		oiksdfMap = NULL;
	}

	ReleaseMutex(hMutex);
	CloseHandle(hMutex);
}
