/*******************************************************************/
/* cpp-   Tabula     */
/*  : C:\cascade\regions.sdf                                */
/*******************************************************************/

#if _MSC_VER >= 1300
#define _CRT_SECURE_NO_DEPRECATE 1
#pragma message("defined _CRT_SECURE_NO_DEPRECATE = 1")
#endif

#include "stdafx.h"
#include <stdio.h>
#include <malloc.h>
#include "regions.h"

//    
//: pBuf -   , nPos -   , data -   , size - 
static void ReadBuf(const char* pBuf, int *nPos, void* data, int size)
{
	memcpy(data, pBuf+(*nPos), size);
	(*nPos) += size;	
}

//    
//: pBuf -   , nPos -   , _ch -   
static void ReadStrBuf(const char* pBuf, int *nPos, char* _ch)
{
	WORD len;
	ReadBuf(pBuf, nPos, &len, sizeof(len));
	ReadBuf(pBuf, nPos, _ch, len);
}

//        
static void GetInfoAboutSdf(const char* p_tBuf, struct sTable** pTable)
{
	int		m_nPos	= 0;
	WORD	nCountT	= 0;
	WORD	iT		= 0;
	WORD	iF		= 0;
	BYTE	byrec	= 0;
	DWORD	tPos	= 0; 
	DWORD	off		= 0;
	BYTE	version = 0;
	DWORD	currentRecord = 0;
	
 	ReadBuf(p_tBuf, &m_nPos, &nCountT, sizeof(WORD));
	version = HIBYTE(nCountT);
	if(version != 0){
		ReadBuf(p_tBuf, &m_nPos, &nCountT, sizeof(WORD));
	}

	(*pTable) = (struct sTable*)calloc(nCountT, sizeof(struct sTable));
	
	for(iT = 0; iT < nCountT; iT++){

		(*pTable)[iT].off = m_nPos;

		ReadStrBuf(p_tBuf, &m_nPos, (*pTable)[iT].name);
		ReadBuf(p_tBuf, &m_nPos, &(*pTable)[iT].nCountR, sizeof(DWORD));		

		//    1      ,
		//     
		if(version != 0){
			(*pTable)[iT].p_CurRecord = (DWORD*)&p_tBuf[m_nPos];
			ReadBuf(p_tBuf, &m_nPos, &currentRecord, sizeof(DWORD));
		}

		ReadBuf(p_tBuf, &m_nPos, &(*pTable)[iT].nCountF, sizeof(WORD));
		
		(*pTable)[iT].infoField = (struct sField*)calloc((*pTable)[iT].nCountF, sizeof(struct sField));

		for(iF = 0; iF < (*pTable)[iT].nCountF; iF++){

			(*pTable)[iT].infoField[iF].off = m_nPos;
			ReadStrBuf(p_tBuf, &m_nPos, (*pTable)[iT].infoField[iF].name);
			ReadBuf(p_tBuf, &m_nPos, &(*pTable)[iT].infoField[iF].type, sizeof(WORD));
			ReadBuf(p_tBuf, &m_nPos, &byrec, sizeof(BYTE));

		}

		byrec = 0;		
		ReadBuf(p_tBuf, &m_nPos, &byrec, sizeof(BYTE));

		tPos = m_nPos;
		(*pTable)[iT].offData = m_nPos;

		if(byrec){ // 

			for(iF=0, off=0; iF < (*pTable)[iT].nCountF; iF++){

				(*pTable)[iT].infoField[iF].offData = tPos;
				off += TYPESIZE((*pTable)[iT].infoField[iF].type);

			}

			(*pTable)[iT].SizeOfFields = off;
			m_nPos = tPos + off*(*pTable)[iT].nCountR;

		}

		else{

			for(iF = 0, off = tPos; iF < (*pTable)[iT].nCountF; iF++){

				(*pTable)[iT].infoField[iF].offData = off;
				off += TYPESIZE((*pTable)[iT].infoField[iF].type)*(*pTable)[iT].nCountR;

			}

			m_nPos = off;
			(*pTable)[iT].SizeOfFields = off - tPos;

		}
	}
}

//      
static BYTE GetOffsetDataByRec(const struct sTable* pTable, DWORD index, DWORD* off)
{
	DWORD size = _msize((struct sTable*)pTable) / sizeof(struct sTable);
	
	if(index >= 0 && index < size && pTable[index].nCountF > 0)
	{
		(*off) = pTable[index].infoField[0].offData;
		return (BYTE)1;
	}
	else
		return 0;
	
}

//  
static BYTE GetOffsetData(const struct sTable* pTable, const char* field, DWORD* off)
{
	DWORD	size		= _msize((struct sTable*)pTable)/sizeof(struct sTable);
	DWORD	iT			= 0;
	WORD	iF			= 0;
	char	_ch1		= '\\';
	BYTE	find_ch1	= 0;
	char	_ch2		= '.';
	BYTE find_ch2		= 0;
	char *res1			= 0;
	char *res2			= 0;
	char *pdest			= 0;
	int len				= -1;

	for(iT = 0; iT < size; iT++){

		for(iF = 0; iF < pTable[iT].nCountF; iF++){

			pdest = strchr(pTable[iT].infoField[iF].name, _ch1);
			len = pdest - pTable[iT].infoField[iF].name;

			if(len >= 0){

				find_ch1 = 1;
				res1 = (char*)calloc(len + 1, sizeof(char));
				strncpy(res1, pTable[iT].infoField[iF].name, len);
				res1[len] = '\0';

			}

			len = -1;
			pdest = strchr(res1, _ch2);
			len = pdest - res1;

			if(len >= 0){

				find_ch2 = 1;
				res2 = (char*)calloc(len + 1, sizeof(char));
				strncpy(res2, res1, len);
				res2[len] = '\0';

			}

			if(find_ch2 && find_ch1){

				if (strcmp(field, res2) == 0){

					(*off) = pTable[iT].infoField[iF].offData;

					free((void*)res2); free((void*)res1);
					return (BYTE)1;

				}

			}

			else if(find_ch1 && !find_ch2){

				if (strcmp(field, res1) == 0){

					(*off) = pTable[iT].infoField[iF].offData;

					free((void*)res1);
					return (BYTE)1;

				}

			}
			
			if(find_ch1) 
				free((void*)res1);

			find_ch1 = 0;

			if(find_ch2) 
				free((void*)res2);

			find_ch2 = 0;

		}
		
	}

	return (BYTE)0;
}

//   
static int FindTable(const struct sTable *pTable, const char *szTableName)
{
	DWORD size = _msize((struct sTable*)pTable) / sizeof(struct sTable);
	
	DWORD iT = 0;
	for(/*iT = 0*/; iT < size; iT++){
		
		if(strncmp(pTable[iT].name, szTableName, strlen(szTableName)) == 0)
			return (int)iT;
		
	}
	
	return -1;

}

//     - 
static DWORD* GetTableRecordsAddress(const struct sTable *pTable, DWORD index)
{
	DWORD size = _msize((struct sTable*)pTable) / sizeof(struct sTable);
	
	if(index >= 0 && index < size)
		return pTable[index].p_CurRecord;
	else
		return 0;
}

//    - 
static DWORD GetTableRecordsMax(const struct sTable *pTable, DWORD index)
{
	DWORD size = _msize((struct sTable*)pTable) / sizeof(struct sTable);
	
	if(index >= 0 && index < size)
		return pTable[index].nCountR;
	else
		return 0;
}

//  
static void DeleteInfoSdf(struct sTable** pTable)
{
	DWORD size	= 0;
	DWORD iT	= 0;
	
	size = _msize((*pTable))/sizeof(struct sTable);

	for(iT = 0; iT < size; iT++)
 		free((*pTable)[iT].infoField);		

	if(size)
  		free((*pTable));
}

//     SUMREGIONS
DWORD SUMREGIONS_max = 0;
DWORD *p_SUMREGIONS = NULL;
c100   *SUMNAMEPARAM;
float  *SUMVALUES;

//     
DWORD temp_max = 0;
DWORD *p_temp = NULL;
short  *CurSection;
short  *Temp2;

//       
DWORD SECTION_max = 0;
DWORD *p_SECTION = NULL;
float  *LOS_R;
float  *LOS_I;
float  *LOS_R_C;
float  *LOS_I_C;
float  *Sech_Limits_Down_Act;
float  *Sech_Limits_Down_Rea;
float  *Sech_Limits_Up_Act;
float  *Sech_Limits_Up_Rea;
c128   *Sech_Name;

//         
DWORD CONNECT_max = 0;
DWORD *p_CONNECT = NULL;
short  *INTER_ST;
short  *INTER_END;
float  *INTER_L_R;
float  *INTER_L_I;
float  *INTER_B_R;
float  *INTER_B_I;
float  *INTER_L_R_C;
float  *INTER_L_I_C;
float  *INTER_B_R_C;
float  *INTER_B_I_C;

//        
DWORD REG_INF_max = 0;
DWORD *p_REG_INF = NULL;
c50    *REG_TAB_Name;
float  *REG_TAB_SALDO_REAL;
float  *REG_TAB_SALDO_IMAG;
float  *REG_TAB_SALDO_REAL_INTEGR;
float  *REG_TAB_SALDO_IMAG_INTEGR;
float  *REG_TAB_LOSES_REAL;
float  *REG_TAB_LOSES_IMAG;
float  *REG_TAB_LOS_R_C;
float  *REG_TAB_LOS_I_C;
float  *REG_TAB_GEN_REAL_C;
float  *REG_TAB_GEN_IMAG_C;
float  *REG_TAB_GEN_REAL;
float  *REG_TAB_GEN_IMAG;
float  *REG_TAB_LD_REAL_C;
float  *REG_TAB_LD_IMAG_C;
float  *REG_TAB_LD_REAL;
float  *REG_TAB_LD_IMAG;
float  *REG_PLAN_LOAD_C;
float  *REG_PLAN_GEN_REAL_C;
float  *REG_PLAN_SALDO_REAL_C;

//           
DWORD MISS_LOAD_max = 0;
DWORD *p_MISS_LOAD = NULL;
float  *ML_R_C;
float  *ML_I_C;
float  *ML_R;
float  *ML_I;
float  *ML_N_R;
float  *ML_N_I;
float  *ML_DF;
float  *ML_DF_C;
float  *ML_DU;
float  *ML_DU_C;

//         
DWORD MISS_LOAD_GEN_max = 0;
DWORD *p_MISS_LOAD_GEN = NULL;
float  *MGLG_MEN_C;
float  *MGLG_MEN;
float  *MGLG_COAST;

//   
#define regionsError \
{\
	p_SUMREGIONS = NULL;\
	p_temp = NULL;\
	p_SECTION = NULL;\
	p_CONNECT = NULL;\
	p_REG_INF = NULL;\
	p_MISS_LOAD = NULL;\
	p_MISS_LOAD_GEN = NULL;\
\
	SUMREGIONS_max = 0;\
	temp_max = 0;\
	SECTION_max = 0;\
	CONNECT_max = 0;\
	REG_INF_max = 0;\
	MISS_LOAD_max = 0;\
	MISS_LOAD_GEN_max = 0;\
\
	SUMNAMEPARAM = NULL;\
	SUMVALUES = NULL;\
	CurSection = NULL;\
	Temp2 = NULL;\
	LOS_R = NULL;\
	LOS_I = NULL;\
	LOS_R_C = NULL;\
	LOS_I_C = NULL;\
	Sech_Limits_Down_Act = NULL;\
	Sech_Limits_Down_Rea = NULL;\
	Sech_Limits_Up_Act = NULL;\
	Sech_Limits_Up_Rea = NULL;\
	Sech_Name = NULL;\
	INTER_ST = NULL;\
	INTER_END = NULL;\
	INTER_L_R = NULL;\
	INTER_L_I = NULL;\
	INTER_B_R = NULL;\
	INTER_B_I = NULL;\
	INTER_L_R_C = NULL;\
	INTER_L_I_C = NULL;\
	INTER_B_R_C = NULL;\
	INTER_B_I_C = NULL;\
	REG_TAB_Name = NULL;\
	REG_TAB_SALDO_REAL = NULL;\
	REG_TAB_SALDO_IMAG = NULL;\
	REG_TAB_SALDO_REAL_INTEGR = NULL;\
	REG_TAB_SALDO_IMAG_INTEGR = NULL;\
	REG_TAB_LOSES_REAL = NULL;\
	REG_TAB_LOSES_IMAG = NULL;\
	REG_TAB_LOS_R_C = NULL;\
	REG_TAB_LOS_I_C = NULL;\
	REG_TAB_GEN_REAL_C = NULL;\
	REG_TAB_GEN_IMAG_C = NULL;\
	REG_TAB_GEN_REAL = NULL;\
	REG_TAB_GEN_IMAG = NULL;\
	REG_TAB_LD_REAL_C = NULL;\
	REG_TAB_LD_IMAG_C = NULL;\
	REG_TAB_LD_REAL = NULL;\
	REG_TAB_LD_IMAG = NULL;\
	REG_PLAN_LOAD_C = NULL;\
	REG_PLAN_GEN_REAL_C = NULL;\
	REG_PLAN_SALDO_REAL_C = NULL;\
	ML_R_C = NULL;\
	ML_I_C = NULL;\
	ML_R = NULL;\
	ML_I = NULL;\
	ML_N_R = NULL;\
	ML_N_I = NULL;\
	ML_DF = NULL;\
	ML_DF_C = NULL;\
	ML_DU = NULL;\
	ML_DU_C = NULL;\
	MGLG_MEN_C = NULL;\
	MGLG_MEN = NULL;\
	MGLG_COAST = NULL;\
\
	ReleaseMutex(hMutex);\
	CloseHandle(hMutex);\
	hMutex=NULL;\
\
	CloseHandle(hFile);\
	hFile=NULL;\
\
	return 0;\
}

LPVOID regionsBuf = NULL;
HANDLE regionsMap = NULL;

struct sTable *pregionsSdf = NULL;

int regionsOpen(LPCTSTR name)
{
	DWORD off = 0;
	BYTE offset = 0;
	int result = 0;
	char *p = 0;
	char *pBase = 0;
	char fname[MAX_PATH] = {0};
	char mname[MAX_PATH] = {0};
	HANDLE hMutex     = 0;
	HANDLE hFile      = 0;
	DWORD  sizeFile   = 0;
	int   indexTable = -1;

	if(name == NULL)
		strcpy(fname, "regions.sdf");
	else
		strcpy(fname, name);

	if(strchr(fname, ':') == NULL){
		char dir[MAX_PATH] = {0};
		GetModuleFileName(NULL, dir, sizeof(dir));
		*(strrchr(dir, '\\') + 1) = '\0';
		strcat(dir, fname);
		strcpy(fname,dir);
	}

	//GetFullPathName(fname, sizeof(mname), mname, &p);
	GetLongPathName(fname, mname, sizeof(mname));
	_strlwr(mname);

	p=mname;
	while(*p){
		if(*p<'0') *p= '_';
		if(*p>'9' && *p<'A') *p= '_';
		if(*p>'z') *p= '_';
		if(*p>'Z' && *p<'a') *p= '_';
		p++;
	}

	hMutex = CreateMutex(NULL, FALSE, "__regions_mutex");

	WaitForSingleObject(hMutex, INFINITE);

	regionsMap = OpenFileMapping(FILE_MAP_ALL_ACCESS, FALSE, mname);

	if(regionsMap == NULL){

		hFile = CreateFile(fname, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
		if(hFile == INVALID_HANDLE_VALUE)
			regionsError

		sizeFile = GetFileSize(hFile, NULL);

		regionsMap = CreateFileMapping(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, sizeFile, mname);
		if(regionsMap == NULL)
			regionsError

		regionsBuf = MapViewOfFile(regionsMap, FILE_MAP_ALL_ACCESS, 0, 0, 0);
		if(regionsBuf == NULL)
			regionsError

		if(!ReadFile(hFile, regionsBuf, sizeFile, &sizeFile, NULL))
			regionsError

		CloseHandle(hFile);

		result = 2;

	}
	else{

		regionsBuf = MapViewOfFile(regionsMap, FILE_MAP_ALL_ACCESS, 0, 0, 0);
		if(regionsBuf == NULL)
			regionsError

		result = 1;
	}

	pBase = (char*)regionsBuf;

	GetInfoAboutSdf(pBase, &pregionsSdf);

	indexTable = FindTable(pregionsSdf, "SUMREGIONS");
	if(indexTable == -1)
		regionsError
	else{
		p_SUMREGIONS = GetTableRecordsAddress(pregionsSdf, indexTable);
		SUMREGIONS_max = GetTableRecordsMax(pregionsSdf, indexTable);
	}

	indexTable = FindTable(pregionsSdf, "temp");
	if(indexTable == -1)
		regionsError
	else{
		p_temp = GetTableRecordsAddress(pregionsSdf, indexTable);
		temp_max = GetTableRecordsMax(pregionsSdf, indexTable);
	}

	indexTable = FindTable(pregionsSdf, "SECTION");
	if(indexTable == -1)
		regionsError
	else{
		p_SECTION = GetTableRecordsAddress(pregionsSdf, indexTable);
		SECTION_max = GetTableRecordsMax(pregionsSdf, indexTable);
	}

	indexTable = FindTable(pregionsSdf, "CONNECT");
	if(indexTable == -1)
		regionsError
	else{
		p_CONNECT = GetTableRecordsAddress(pregionsSdf, indexTable);
		CONNECT_max = GetTableRecordsMax(pregionsSdf, indexTable);
	}

	indexTable = FindTable(pregionsSdf, "REG_INF");
	if(indexTable == -1)
		regionsError
	else{
		p_REG_INF = GetTableRecordsAddress(pregionsSdf, indexTable);
		REG_INF_max = GetTableRecordsMax(pregionsSdf, indexTable);
	}

	indexTable = FindTable(pregionsSdf, "MISS_LOAD");
	if(indexTable == -1)
		regionsError
	else{
		p_MISS_LOAD = GetTableRecordsAddress(pregionsSdf, indexTable);
		MISS_LOAD_max = GetTableRecordsMax(pregionsSdf, indexTable);
	}

	indexTable = FindTable(pregionsSdf, "MISS_LOAD_GEN");
	if(indexTable == -1)
		regionsError
	else{
		p_MISS_LOAD_GEN = GetTableRecordsAddress(pregionsSdf, indexTable);
		MISS_LOAD_GEN_max = GetTableRecordsMax(pregionsSdf, indexTable);
	}

	offset = GetOffsetData(pregionsSdf, "SUMNAMEPARAM", &off);
	if(offset)
		SUMNAMEPARAM = (c100*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "SUMVALUES", &off);
	if(offset)
		SUMVALUES = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "CurSection", &off);
	if(offset)
		CurSection = (short*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "Temp2", &off);
	if(offset)
		Temp2 = (short*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "LOS_R", &off);
	if(offset)
		LOS_R = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "LOS_I", &off);
	if(offset)
		LOS_I = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "LOS_R_C", &off);
	if(offset)
		LOS_R_C = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "LOS_I_C", &off);
	if(offset)
		LOS_I_C = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "Sech_Limits_Down_Act", &off);
	if(offset)
		Sech_Limits_Down_Act = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "Sech_Limits_Down_Rea", &off);
	if(offset)
		Sech_Limits_Down_Rea = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "Sech_Limits_Up_Act", &off);
	if(offset)
		Sech_Limits_Up_Act = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "Sech_Limits_Up_Rea", &off);
	if(offset)
		Sech_Limits_Up_Rea = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "Sech_Name", &off);
	if(offset)
		Sech_Name = (c128*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "INTER_ST", &off);
	if(offset)
		INTER_ST = (short*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "INTER_END", &off);
	if(offset)
		INTER_END = (short*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "INTER_L_R", &off);
	if(offset)
		INTER_L_R = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "INTER_L_I", &off);
	if(offset)
		INTER_L_I = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "INTER_B_R", &off);
	if(offset)
		INTER_B_R = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "INTER_B_I", &off);
	if(offset)
		INTER_B_I = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "INTER_L_R_C", &off);
	if(offset)
		INTER_L_R_C = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "INTER_L_I_C", &off);
	if(offset)
		INTER_L_I_C = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "INTER_B_R_C", &off);
	if(offset)
		INTER_B_R_C = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "INTER_B_I_C", &off);
	if(offset)
		INTER_B_I_C = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "REG_TAB_Name", &off);
	if(offset)
		REG_TAB_Name = (c50*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "REG_TAB_SALDO_REAL", &off);
	if(offset)
		REG_TAB_SALDO_REAL = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "REG_TAB_SALDO_IMAG", &off);
	if(offset)
		REG_TAB_SALDO_IMAG = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "REG_TAB_SALDO_REAL_INTEGR", &off);
	if(offset)
		REG_TAB_SALDO_REAL_INTEGR = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "REG_TAB_SALDO_IMAG_INTEGR", &off);
	if(offset)
		REG_TAB_SALDO_IMAG_INTEGR = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "REG_TAB_LOSES_REAL", &off);
	if(offset)
		REG_TAB_LOSES_REAL = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "REG_TAB_LOSES_IMAG", &off);
	if(offset)
		REG_TAB_LOSES_IMAG = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "REG_TAB_LOS_R_C", &off);
	if(offset)
		REG_TAB_LOS_R_C = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "REG_TAB_LOS_I_C", &off);
	if(offset)
		REG_TAB_LOS_I_C = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "REG_TAB_GEN_REAL_C", &off);
	if(offset)
		REG_TAB_GEN_REAL_C = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "REG_TAB_GEN_IMAG_C", &off);
	if(offset)
		REG_TAB_GEN_IMAG_C = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "REG_TAB_GEN_REAL", &off);
	if(offset)
		REG_TAB_GEN_REAL = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "REG_TAB_GEN_IMAG", &off);
	if(offset)
		REG_TAB_GEN_IMAG = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "REG_TAB_LD_REAL_C", &off);
	if(offset)
		REG_TAB_LD_REAL_C = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "REG_TAB_LD_IMAG_C", &off);
	if(offset)
		REG_TAB_LD_IMAG_C = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "REG_TAB_LD_REAL", &off);
	if(offset)
		REG_TAB_LD_REAL = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "REG_TAB_LD_IMAG", &off);
	if(offset)
		REG_TAB_LD_IMAG = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "REG_PLAN_LOAD_C", &off);
	if(offset)
		REG_PLAN_LOAD_C = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "REG_PLAN_GEN_REAL_C", &off);
	if(offset)
		REG_PLAN_GEN_REAL_C = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "REG_PLAN_SALDO_REAL_C", &off);
	if(offset)
		REG_PLAN_SALDO_REAL_C = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "ML_R_C", &off);
	if(offset)
		ML_R_C = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "ML_I_C", &off);
	if(offset)
		ML_I_C = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "ML_R", &off);
	if(offset)
		ML_R = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "ML_I", &off);
	if(offset)
		ML_I = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "ML_N_R", &off);
	if(offset)
		ML_N_R = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "ML_N_I", &off);
	if(offset)
		ML_N_I = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "ML_DF", &off);
	if(offset)
		ML_DF = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "ML_DF_C", &off);
	if(offset)
		ML_DF_C = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "ML_DU", &off);
	if(offset)
		ML_DU = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "ML_DU_C", &off);
	if(offset)
		ML_DU_C = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "MGLG_MEN_C", &off);
	if(offset)
		MGLG_MEN_C = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "MGLG_MEN", &off);
	if(offset)
		MGLG_MEN = (float*)(pBase + off);
	else
		regionsError

	offset = GetOffsetData(pregionsSdf, "MGLG_COAST", &off);
	if(offset)
		MGLG_COAST = (float*)(pBase + off);
	else
		regionsError

	ReleaseMutex(hMutex);
	CloseHandle(hMutex);

	return result;
}

void regionsClose()
{
	HANDLE hMutex = 0;
	hMutex = CreateMutex(NULL, FALSE, "__regions_mutex");
	WaitForSingleObject(hMutex, INFINITE);

	if(pregionsSdf != NULL)
	{
		DeleteInfoSdf(&pregionsSdf);
		pregionsSdf = NULL;
	}

	if(regionsBuf)
	{
		UnmapViewOfFile(regionsBuf);
		regionsBuf = NULL;
	}

	if(regionsMap)
	{
		CloseHandle(regionsMap);
		regionsMap = NULL;
	}

	ReleaseMutex(hMutex);
	CloseHandle(hMutex);
}
