/*******************************************************************/
/* cpp-   Tabula     */
/*  : c:\casfsk\tren.sdf                                    */
/*******************************************************************/

#include "stdafx.h"
#include <stdio.h>
#include <malloc.h>
#include "tren.h"

//    
//: pBuf -   , nPos -   , data -   , size - 
static void ReadBuf(const char* pBuf, int *nPos, void* data, int size)
{
	memcpy(data, pBuf+(*nPos), size);
	(*nPos) += size;	
}

//    
//: pBuf -   , nPos -   , _ch -   
static void ReadStrBuf(const char* pBuf, int *nPos, char* _ch)
{
	WORD len;
	ReadBuf(pBuf, nPos, &len, sizeof(len));
	ReadBuf(pBuf, nPos, _ch, len);
}

//        
static void GetInfoAboutSdf(const char* p_tBuf, struct sTable** pTable)
{
	int		m_nPos	= 0;
	WORD	nCountT	= 0;
	WORD	iT		= 0;
	WORD	iF		= 0;
	BYTE	byrec	= 0;
	DWORD	tPos	= 0; 
	DWORD	off		= 0;
	BYTE	version = 0;
	DWORD	currentRecord = 0;
	
 	ReadBuf(p_tBuf, &m_nPos, &nCountT, sizeof(WORD));
	version = HIBYTE(nCountT);
	if(version != 0){
		ReadBuf(p_tBuf, &m_nPos, &nCountT, sizeof(WORD));
	}

	(*pTable) = (struct sTable*)calloc(nCountT, sizeof(struct sTable));
	
	for(iT = 0; iT < nCountT; iT++){

		(*pTable)[iT].off = m_nPos;

		ReadStrBuf(p_tBuf, &m_nPos, (*pTable)[iT].name);
		ReadBuf(p_tBuf, &m_nPos, &(*pTable)[iT].nCountR, sizeof(DWORD));		

		//    1      ,
		//     
		if(version != 0){
			(*pTable)[iT].p_CurRecord = (DWORD*)&p_tBuf[m_nPos];
			ReadBuf(p_tBuf, &m_nPos, &currentRecord, sizeof(DWORD));
		}

		ReadBuf(p_tBuf, &m_nPos, &(*pTable)[iT].nCountF, sizeof(WORD));
		
		(*pTable)[iT].infoField = (struct sField*)calloc((*pTable)[iT].nCountF, sizeof(struct sField));

		for(iF = 0; iF < (*pTable)[iT].nCountF; iF++){

			(*pTable)[iT].infoField[iF].off = m_nPos;
			ReadStrBuf(p_tBuf, &m_nPos, (*pTable)[iT].infoField[iF].name);
			ReadBuf(p_tBuf, &m_nPos, &(*pTable)[iT].infoField[iF].type, sizeof(WORD));
			ReadBuf(p_tBuf, &m_nPos, &byrec, sizeof(BYTE));

		}

		byrec = 0;		
		ReadBuf(p_tBuf, &m_nPos, &byrec, sizeof(BYTE));

		tPos = m_nPos;
		(*pTable)[iT].offData = m_nPos;

		if(byrec){ // 

			for(iF=0, off=0; iF < (*pTable)[iT].nCountF; iF++){

				(*pTable)[iT].infoField[iF].offData = tPos;
				off += TYPESIZE((*pTable)[iT].infoField[iF].type);

			}

			(*pTable)[iT].SizeOfFields = off;
			m_nPos = tPos + off*(*pTable)[iT].nCountR;

		}

		else{

			for(iF = 0, off = tPos; iF < (*pTable)[iT].nCountF; iF++){

				(*pTable)[iT].infoField[iF].offData = off;
				off += TYPESIZE((*pTable)[iT].infoField[iF].type)*(*pTable)[iT].nCountR;

			}

			m_nPos = off;
			(*pTable)[iT].SizeOfFields = off - tPos;

		}
	}
}

//      
static BYTE GetOffsetDataByRec(const struct sTable* pTable, DWORD index, DWORD* off)
{
	size_t size = _msize((struct sTable*)pTable) / sizeof(struct sTable);
	
	if(index >= 0 && index < size && pTable[index].nCountF > 0)
	{
		(*off) = pTable[index].infoField[0].offData;
		return (BYTE)1;
	}
	else
		return 0;
	
}

//  
static BYTE GetOffsetData(const struct sTable* pTable, const char* field, DWORD* off)
{
	size_t	size		= _msize((struct sTable*)pTable)/sizeof(struct sTable);
	DWORD	iT			= 0;
	WORD	iF			= 0;
	char	_ch1		= '\\';
	BYTE	find_ch1	= 0;
	char	_ch2		= '.';
	BYTE find_ch2		= 0;
	char *res1			= 0;
	char *res2			= 0;
	char *pdest			= 0;
	int len				= -1;

	for(iT = 0; iT < size; iT++){

		for(iF = 0; iF < pTable[iT].nCountF; iF++){

			pdest = strchr(pTable[iT].infoField[iF].name, _ch1);
			if(pdest!=NULL){
				len = pdest - pTable[iT].infoField[iF].name;
				find_ch1 = 1;
				res1 = (char*)calloc((size_t)len + 1, sizeof(char));
				memcpy(res1, pTable[iT].infoField[iF].name, (size_t)len);
				res1[len] = '\0';
			}

			len = -1;
			pdest = strchr(res1, _ch2);
			if(pdest!=NULL){
				len = pdest - res1;
				find_ch2 = 1;
				res2 = (char*)calloc(len + 1, sizeof(char));
				memcpy(res2, res1, len);
				res2[len] = '\0';
			}

			if(find_ch2 && find_ch1){
				if (strcmp(field, res2) == 0){

					(*off) = pTable[iT].infoField[iF].offData;

					free((void*)res2); free((void*)res1);
					return (BYTE)1;
				}
			}

			else if(find_ch1 && !find_ch2){
				if (strcmp(field, res1) == 0){
					(*off) = pTable[iT].infoField[iF].offData;
					free((void*)res1);
					return (BYTE)1;
				}
			}
			
			if(find_ch1) 
				free((void*)res1);

			find_ch1 = 0;

			if(find_ch2) 
				free((void*)res2);

			find_ch2 = 0;
		}
		
	}

	return (BYTE)0;
}

//   
static int FindTable(const struct sTable *pTable, const char *szTableName)
{
	size_t size = _msize((struct sTable*)pTable) / sizeof(struct sTable);
	
	DWORD iT = 0;
	for(/*iT = 0*/; iT < size; iT++){
		
		if(strncmp(pTable[iT].name, szTableName, strlen(szTableName)) == 0)
			return (int)iT;
		
	}
	
	return -1;

}

//     - 
static DWORD* GetTableRecordsAddress(const struct sTable *pTable, DWORD index)
{
	size_t size = _msize((struct sTable*)pTable) / sizeof(struct sTable);
	
	if(index >= 0 && index < size)
		return pTable[index].p_CurRecord;
	else
		return 0;
}

//    - 
static DWORD GetTableRecordsMax(const struct sTable *pTable, DWORD index)
{
	size_t size = _msize((struct sTable*)pTable) / sizeof(struct sTable);
	
	if(index >= 0 && index < size)
		return pTable[index].nCountR;
	else
		return 0;
}

//  
static void DeleteInfoSdf(struct sTable** pTable)
{
	size_t size	= 0;
	DWORD iT	= 0;
	
	size = _msize((*pTable))/sizeof(struct sTable);

	for(iT = 0; iT < size; iT++)
 		free((*pTable)[iT].infoField);		

	if(size)
  		free((*pTable));
}

//     
DWORD arnt_max = 0;
DWORD *p_arnt = NULL;
int    *arnt_leading;
c20    *arnt_followings;

//     -  
DWORD DDopVoltLim_max = 0;
DWORD *p_DDopVoltLim = NULL;
c15    *ddvl_Unom;
float  *ddvl_duration;
float  *ddvl_coefficient;
float  *ddvl_UnomMin;
float  *ddvl_UnomMax;

//       
DWORD Umax_max = 0;
DWORD *p_Umax = NULL;
float  *umax_nom;
float  *umax_max;

//       
DWORD gvo_max = 0;
DWORD *p_gvo = NULL;
short  *gvo_SubId;
BYTE   *gvo_Sequen;
int    *gvo_BrkId;
c50    *gvo_SubName;
c50    *gvo_LoadDesc;
float  *gvo_LoadVal;
short  *gvo_MaxTime;
c10    *gvo_Who;

//      ...
DWORD aopo_max = 0;
DWORD *p_aopo = NULL;
int    *aopo_id;
c50    *aopo_TokLines;
c50    *aopo_TokDesc;
float  *aopo_TokSummer;
float  *aopo_TokWinter;
c50    *aopo_LoadBreakers;
c50    *aopo_LoadDesc;
c50    *aopo_LineBreakers;
BYTE   *aopo_work;
BYTE   *aopo_out;

//      ..
DWORD aosn_max = 0;
DWORD *p_aosn = NULL;
int    *aosn_id;
c50    *aosn_VoltBuses;
c50    *aosn_VoltDesc;
float  *aosn_VoltMin;
c50    *aosn_OffBreakers;
c50    *aosn_OffDesc;
BYTE   *aosn_time;
BYTE   *aosn_work;
BYTE   *aosn_out;

//     
DWORD avr_max = 0;
DWORD *p_avr = NULL;
BYTE   *avr_id;
c50    *avr_name;
int    *avr_subid;
float  *avr_volt0;
int    *avr_ts0;
int    *avr_ts1;
int    *avr_ts2;
c4     *avr_algo;
BYTE   *avr_work;
BYTE   *avr_out;
int    *avr_bus1;
int    *avr_bus2;

//      
DWORD TsLog_max = 0;
DWORD *p_TsLog = NULL;
int    *tslog_DevId;
c50    *tslog_DevName;
BYTE   *tslog_TsType;
int    *tslog_SubId;
c30    *tslog_SubDispName;
BYTE   *tslog_NewState;
int    *tslog_Tim;

//      
DWORD EndLines_max = 0;
DWORD *p_EndLines = NULL;
int    *eline_id;
short  *eline_subid;
c50    *eline_name;
float  *eline_volt0;
float  *eline_p;
float  *eline_q;
float  *eline_i;
float  *eline_p0;
float  *eline_q0;
BYTE   *eline_on;

//     ()
DWORD substn_max = 0;
DWORD *p_substn = NULL;
int    *sub_id;
c50    *sub_name;
c20    *sub_name1;
c12    *sub_folder;
c30    *sub_dispname;
float  *sub_volt0;
BYTE   *sub_isstation;
float  *sub_volt;
float  *sub_freq;
float  *sub_sal1;
float  *sub_p;
float  *sub_q;
float  *sub_frct;
float  *sub_stk;
BYTE   *sub_open;
c255   *sub_file;
c50    *sub_regim;
BYTE   *sub_avr;
BYTE   *sub_kvit;
c15    *sub_pmes;
BYTE   *sub_tu;

//     
DWORD station_max = 0;
DWORD *p_station = NULL;
int    *station_id;
c50    *station_name;
float  *station_pagsal;
float  *station_ak;
float  *station_pqg1;
float  *station_pqg;
float  *station_sal;

//     Marks
DWORD Marks_max = 0;
DWORD *p_Marks = NULL;
int    *MrkId;
int    *MrkTime;
int    *MrkType;
c30    *MrkName;
c20    *MrkSymbol;
short  *MrkIcon;
int    *MrkX;
int    *MrkY;
int    *MrkTypeEq;
int    *MrkCodeEq;
c70    *MrkEqName;
c30    *MrkSubDispName;
c255   *MrkComment;
c150   *MrkAuthor;

//     Zvk
DWORD Zvk_max = 0;
DWORD *p_Zvk = NULL;
int    *zvk_Id;
BYTE   *zvk_Avar;
BYTE   *zvk_State;
int    *zvk_BegTime;
int    *zvk_EndTime;
int    *zvk_DevType;
int    *zvk_DevId;
c70    *zvk_DevName;
int    *zvk_SubId;
c30    *zvk_SubDispName;

//     sms_zvk
DWORD sms_zvk_max = 0;
DWORD *p_sms_zvk = NULL;
BYTE   *ShowMode;
BYTE   *StateTimeFilter;
int    *BegTimeFilter;
int    *EndTimeFilter;
c255   *DeviceFilter;
c50    *StateFilter;

//     zvkdevices
DWORD zvkdevices_max = 0;
DWORD *p_zvkdevices = NULL;
BYTE   *Type;
double *ModelId;

//     
DWORD abr_max = 0;
DWORD *p_abr = NULL;
int    *abr_ts;
c50    *abr_name;
int    *abr_SubId;
BYTE   *abr_type;
float  *abr_volt0;
BYTE   *abr_OperCur;
BYTE   *abr_CanSync;
BYTE   *abr_SyncState;
BYTE   *abr_NeedCheck;
float  *abr_per1;
float  *abr_peq1;
float  *abr_tok1;
float  *abr_per2;
float  *abr_peq2;
float  *abr_tok2;

//     
DWORD tsn_max = 0;
DWORD *p_tsn = NULL;
int    *tsn_id;
c50    *tsn_name;
int    *tsn_SubId;
float  *tsn_volt0;
BYTE   *tsn_on;
double *tsn_aload;
double *tsn_rload;
int    *tsn_moved;

//     1
DWORD trans1_max = 0;
DWORD *p_trans1 = NULL;
int    *trans1_id;
c50    *trans1_name;
int    *trans1_SubId;
float  *trans1_volt0;
BYTE   *trans1_on;
double *trans1_aload;
double *trans1_rload;

//     2
DWORD trans2_max = 0;
DWORD *p_trans2 = NULL;
int    *trans2_id;
c30    *trans2_SubDispname;
c50    *trans2_FullName;
c10    *trans2_name;
float  *trans2_Unom1;
float  *trans2_Unom2;
float  *trans2_Snom;
int    *trans2_SubId;
char   *trans2_bkl;
float  *trans2_S;
float  *trans2_per;
float  *trans2_peq;
float  *trans2_Inom1;
float  *trans2_per1;
float  *trans2_peq1;
float  *trans2_S1;
float  *trans2_Inom2;
float  *trans2_per2;
float  *trans2_peq2;
float  *trans2_S2;
float  *trans2_tok1;
float  *trans2_tok2;
int    *trans2_SubInd;
BYTE   *trans2_RpnState;
float  *trans2_DDopVn;
float  *trans2_DDopNn;
int    *trans2_DdopTimeVn;
int    *trans2_DdopTimeNn;
short  *trans2_DdopCountVn;
short  *trans2_DdopCountNn;
short  *trans2_arnt_p;
short  *trans2_arnt_t;
BYTE   *trans2_IsAdopVn;
BYTE   *trans2_IsAdopNn;
short  *trans2_AdopCountVn;
short  *trans2_AdopCountNn;
BYTE   *trans2_IsDdopVn;
BYTE   *trans2_IsDdopNn;

//     3
DWORD trans3_max = 0;
DWORD *p_trans3 = NULL;
int    *trans3_id;
c30    *trans3_SubDispname;
c50    *trans3_FullName;
c10    *trans3_name;
int    *trans3_SubId;
float  *trans3_Unom1;
float  *trans3_Unom2;
float  *trans3_Unom3;
float  *trans3_Snom;
float  *trans3_Inom1;
float  *trans3_Inom2;
int    *trans3_SubInd;
float  *trans3_per1;
float  *trans3_per2;
float  *trans3_per3;
float  *trans3_peq1;
float  *trans3_peq2;
float  *trans3_peq3;
float  *trans3_tok1;
float  *trans3_tok2;
float  *trans3_tok3;
float  *trans3_S1;
BYTE   *trans3_RpnState;
float  *trans3_DDopVn;
float  *trans3_DDopSn;
float  *trans3_DDopNn;
int    *trans3_DdopTimeVn;
int    *trans3_DdopTimeSn;
int    *trans3_DdopTimeNn;
short  *trans3_DdopCountVn;
short  *trans3_DdopCountSn;
short  *trans3_DdopCountNn;
short  *trans3_arnt_p;
short  *trans3_arnt_t;
BYTE   *trans3_IsAdopVn;
BYTE   *trans3_IsAdopSn;
BYTE   *trans3_IsAdopNn;
short  *trans3_AdopCountVn;
short  *trans3_AdopCountSn;
short  *trans3_AdopCountNn;
BYTE   *trans3_IsDdopVn;
BYTE   *trans3_IsDdopSn;
BYTE   *trans3_IsDdopNn;

//     
DWORD fdr_max = 0;
DWORD *p_fdr = NULL;
int    *fdr_id;
c50    *fdr_name;
int    *fdr_SubId;
float  *fdr_volt0;
BYTE   *fdr_on;
double *fdr_aload;
double *fdr_rload;

//      
DWORD mbr_max = 0;
DWORD *p_mbr = NULL;
int    *mbr_ts;
c50    *mbr_name;
int    *mbr_SubId;
BYTE   *mbr_type;
float  *mbr_volt0;
BYTE   *mbr_OperCur;
BYTE   *mbr_slot2;
float  *mbr_per1;
float  *mbr_peq1;
float  *mbr_per2;
float  *mbr_peq2;

//     
DWORD bus_max = 0;
DWORD *p_bus = NULL;
int    *bus_id;
int    *bus_subid;
int    *bus_subind;
BYTE   *bus_type;
c30    *bus_SubDispname;
c15    *bus_name;
float  *bus_volt0;
float  *bus_umin;
float  *bus_umax;
int    *bus_mdlind;
int    *bus_mdlid;
float  *bus_volt;
float  *bus_freq;
float  *bus_p;
float  *bus_q;
float  *bus_g;
float  *bus_aki;
float  *bus_qmax;
float  *bus_qmin;
float  *bus_ust_u;
BYTE   *bus_Fixation;
BYTE   *bus_dead;
int    *bus_DdopTime;
BYTE   *bus_IsDdop;
short  *bus_DdopCount;

//      
DWORD fbus_max = 0;
DWORD *p_fbus = NULL;
int    *fbus_id;
short  *fbus_subid;
int    *fbus_subind;
c15    *fbus_name;
float  *fbus_volt0;
int    *fbus_mdlind;
int    *fbus_mdlid;
BYTE   *fbus_mdlType;
float  *fbus_volt;

//     
DWORD line_max = 0;
DWORD *p_line = NULL;
int    *line_id;
c70    *line_name;
float  *line_volt0;
float  *line_per;
float  *line_peq;
float  *line_tok;
float  *line_per1;
float  *line_peq1;
float  *line_tok1;
float  *line_per2;
float  *line_peq2;
float  *line_tok2;
char   *line_bkl;
BYTE   *line_kvit;
BYTE   *line_inval;
short  *line_SubId1;
short  *line_SubId2;
BYTE   *line_dead;
short  *line_Ddop;
short  *line_Adop;
float  *line_u1;
float  *line_u2;
BYTE   *line_AopoTime;
float  *line_aopoTok;
int    *line_DdopTime;
BYTE   *line_IsDdop;
short  *line_DdopCount;
BYTE   *line_IsAdop;
short  *line_AdopCount;

//      
DWORD LineLim_max = 0;
DWORD *p_LineLim = NULL;
int    *liml_Lnum;
c70    *liml_Name;
short  *liml_Unom;
c80    *liml_DdopTOE;
c80    *liml_AdopTOE;
float  *liml_I;
short  *liml_Ddop;
short  *liml_Adop;
short  *liml_DdopM20;
short  *liml_AdopM20;
short  *liml_DdopM15;
short  *liml_AdopM15;
short  *liml_DdopM10;
short  *liml_AdopM10;
short  *liml_DdopM5;
short  *liml_AdopM5;
short  *liml_Ddop0;
short  *liml_Adop0;
short  *liml_Ddop5;
short  *liml_Adop5;
short  *liml_Ddop10;
short  *liml_Adop10;
short  *liml_Ddop15;
short  *liml_Adop15;
short  *liml_Ddop20;
short  *liml_Adop20;
short  *liml_Ddop25;
short  *liml_Adop25;
short  *liml_Ddop30;
short  *liml_Adop30;
short  *liml_Ddop35;
short  *liml_Adop35;
short  *liml_Ddop40;
short  *liml_Adop40;

//       
DWORD VoltLim_max = 0;
DWORD *p_VoltLim = NULL;
int    *limv_SubId;
int    *limv_SubInd;
c30    *limv_SubDispname;
float  *limv_Unom;
float  *limv_Umin;
float  *limv_Umax;
c50    *limv_ExcepBuses;

//         
DWORD VoltLimBus_max = 0;
DWORD *p_VoltLimBus = NULL;
int    *limvb_BusId;
c15    *limvb_BusName;
c30    *limvb_SubDispname;
float  *limvb_Unom;
float  *limvb_Umin;
float  *limvb_Umax;
float  *limvb_U;
BYTE   *limvb_Out;

//     
DWORD tn_max = 0;
DWORD *p_tn = NULL;
int    *tn_id;
c50    *tn_name;
int    *tn_SubId;
float  *tn_volt0;
BYTE   *tn_res;
BYTE   *tn_nn;
float  *tn_Ua;
float  *tn_Ub;
float  *tn_Uc;
float  *tn_Uab;
float  *tn_Ubc;
float  *tn_Uca;

//     options
DWORD options_max = 0;
DWORD *p_options = NULL;
BYTE   *archm;
BYTE   *Top;
BYTE   *IsolGrn;
BYTE   *AvrOn;
BYTE   *LoadMode;
int    *LoadTime;
int    *ViewTime;
BYTE   *schema;
c70    *LoadFile;
BYTE   *ShowModel;
BYTE   *ShowOik;
BYTE   *LineViewMode;
BYTE   *CurTemp;
BYTE   *WinterNow;
BYTE   *NeedSaveSlice;
short  *IdDopMaxTime;
short  *IdDopTransMaxTime;
BYTE   *IdDopTransPercent;

//     zayavka
DWORD zayavka_max = 0;
DWORD *p_zayavka = NULL;
BYTE   *Mode;
BYTE   *TimeMode;
int    *Beg;
int    *End;
int    *DevMask;
int    *StateMask;

//     
DWORD gen_max = 0;
DWORD *p_gen = NULL;
int    *gen_id;
short  *gen_subid;
c50    *gen_name;
float  *gen_volt0;
float  *gen_val;
float  *gen_aki;
float  *gen_rgen;
float  *gen_qmin;
float  *gen_qmax;
float  *gen_pagsal;
float  *gen_sal;
float  *gen_ust_u;
float  *gen_aload;
float  *gen_rload;
BYTE   *gen_on;
int    *gen_mdlind;
int    *gen_mdlid;

//     
DWORD hbr_max = 0;
DWORD *p_hbr = NULL;
int    *hbr_ts;
c50    *hbr_name;
int    *hbr_SubId;
float  *hbr_volt0;
BYTE   *hbr_EmKey;
BYTE   *hbr_AbrBlock;
BYTE   *hbr_CheckState;
BYTE   *hbr_PowerDrive;

//     
DWORD grn_max = 0;
DWORD *p_grn = NULL;
int    *grn_ts;
c50    *grn_name;
int    *grn_SubId;
float  *grn_volt0;
BYTE   *grn_CheckVolt;
BYTE   *grn_short;

//     
DWORD rct_max = 0;
DWORD *p_rct = NULL;
int    *rct_id;
c50    *rct_name;
int    *rct_SubId;
float  *rct_volt0;
float  *rct_p;
float  *rct_q;
BYTE   *rct_on;

//       ()
DWORD frct_max = 0;
DWORD *p_frct = NULL;
int    *frct_id;
c50    *frct_name;
int    *frct_SubId;
float  *frct_volt0;
float  *frct_q;
float  *frct_qmin;
float  *frct_qmax;
float  *frct_ust_u;
BYTE   *frct_on;
int    *frct_mdlind;
int    *frct_mdlid;

//     
DWORD stk_max = 0;
DWORD *p_stk = NULL;
int    *stk_id;
c50    *stk_name;
int    *stk_SubId;
float  *stk_volt0;
float  *stk_qg;
float  *stk_qmin;
float  *stk_qmax;
float  *stk_ust_q;
float  *stk_ust_u;
BYTE   *stk_on;
int    *stk_mdlind;
int    *stk_mdlid;

//      
DWORD users_max = 0;
DWORD *p_users = NULL;
c50    *usr_name;
c50    *usr_comp;
BYTE   *usr_type;

//     
DWORD toptask_max = 0;
DWORD *p_toptask = NULL;
int    *top_SubId;
c10    *top_Action;
c10    *top_TypeDevice;
int    *top_Device;

//     
DWORD toplog_max = 0;
DWORD *p_toplog = NULL;
int    *toplog_number;
BYTE   *toplog_oldstate;
BYTE   *toplog_newstate;
c50    *toplog_action;
c50    *toplog_object;
c50    *toplog_objname;
c255   *toplog_message;
short  *toplog_rating;

//   
int trenError(HANDLE hMutex)
{
	p_arnt = NULL;
	p_DDopVoltLim = NULL;
	p_Umax = NULL;
	p_gvo = NULL;
	p_aopo = NULL;
	p_aosn = NULL;
	p_avr = NULL;
	p_TsLog = NULL;
	p_EndLines = NULL;
	p_substn = NULL;
	p_station = NULL;
	p_Marks = NULL;
	p_Zvk = NULL;
	p_sms_zvk = NULL;
	p_zvkdevices = NULL;
	p_abr = NULL;
	p_tsn = NULL;
	p_trans1 = NULL;
	p_trans2 = NULL;
	p_trans3 = NULL;
	p_fdr = NULL;
	p_mbr = NULL;
	p_bus = NULL;
	p_fbus = NULL;
	p_line = NULL;
	p_LineLim = NULL;
	p_VoltLim = NULL;
	p_VoltLimBus = NULL;
	p_tn = NULL;
	p_options = NULL;
	p_zayavka = NULL;
	p_gen = NULL;
	p_hbr = NULL;
	p_grn = NULL;
	p_rct = NULL;
	p_frct = NULL;
	p_stk = NULL;
	p_users = NULL;
	p_toptask = NULL;
	p_toplog = NULL;

	arnt_max = 0;
	DDopVoltLim_max = 0;
	Umax_max = 0;
	gvo_max = 0;
	aopo_max = 0;
	aosn_max = 0;
	avr_max = 0;
	TsLog_max = 0;
	EndLines_max = 0;
	substn_max = 0;
	station_max = 0;
	Marks_max = 0;
	Zvk_max = 0;
	sms_zvk_max = 0;
	zvkdevices_max = 0;
	abr_max = 0;
	tsn_max = 0;
	trans1_max = 0;
	trans2_max = 0;
	trans3_max = 0;
	fdr_max = 0;
	mbr_max = 0;
	bus_max = 0;
	fbus_max = 0;
	line_max = 0;
	LineLim_max = 0;
	VoltLim_max = 0;
	VoltLimBus_max = 0;
	tn_max = 0;
	options_max = 0;
	zayavka_max = 0;
	gen_max = 0;
	hbr_max = 0;
	grn_max = 0;
	rct_max = 0;
	frct_max = 0;
	stk_max = 0;
	users_max = 0;
	toptask_max = 0;
	toplog_max = 0;

	arnt_leading = NULL;
	arnt_followings = NULL;
	ddvl_Unom = NULL;
	ddvl_duration = NULL;
	ddvl_coefficient = NULL;
	ddvl_UnomMin = NULL;
	ddvl_UnomMax = NULL;
	umax_nom = NULL;
	umax_max = NULL;
	gvo_SubId = NULL;
	gvo_Sequen = NULL;
	gvo_BrkId = NULL;
	gvo_SubName = NULL;
	gvo_LoadDesc = NULL;
	gvo_LoadVal = NULL;
	gvo_MaxTime = NULL;
	gvo_Who = NULL;
	aopo_id = NULL;
	aopo_TokLines = NULL;
	aopo_TokDesc = NULL;
	aopo_TokSummer = NULL;
	aopo_TokWinter = NULL;
	aopo_LoadBreakers = NULL;
	aopo_LoadDesc = NULL;
	aopo_LineBreakers = NULL;
	aopo_work = NULL;
	aopo_out = NULL;
	aosn_id = NULL;
	aosn_VoltBuses = NULL;
	aosn_VoltDesc = NULL;
	aosn_VoltMin = NULL;
	aosn_OffBreakers = NULL;
	aosn_OffDesc = NULL;
	aosn_time = NULL;
	aosn_work = NULL;
	aosn_out = NULL;
	avr_id = NULL;
	avr_name = NULL;
	avr_subid = NULL;
	avr_volt0 = NULL;
	avr_ts0 = NULL;
	avr_ts1 = NULL;
	avr_ts2 = NULL;
	avr_algo = NULL;
	avr_work = NULL;
	avr_out = NULL;
	avr_bus1 = NULL;
	avr_bus2 = NULL;
	tslog_DevId = NULL;
	tslog_DevName = NULL;
	tslog_TsType = NULL;
	tslog_SubId = NULL;
	tslog_SubDispName = NULL;
	tslog_NewState = NULL;
	tslog_Tim = NULL;
	eline_id = NULL;
	eline_subid = NULL;
	eline_name = NULL;
	eline_volt0 = NULL;
	eline_p = NULL;
	eline_q = NULL;
	eline_i = NULL;
	eline_p0 = NULL;
	eline_q0 = NULL;
	eline_on = NULL;
	sub_id = NULL;
	sub_name = NULL;
	sub_name1 = NULL;
	sub_folder = NULL;
	sub_dispname = NULL;
	sub_volt0 = NULL;
	sub_isstation = NULL;
	sub_volt = NULL;
	sub_freq = NULL;
	sub_sal1 = NULL;
	sub_p = NULL;
	sub_q = NULL;
	sub_frct = NULL;
	sub_stk = NULL;
	sub_open = NULL;
	sub_file = NULL;
	sub_regim = NULL;
	sub_avr = NULL;
	sub_kvit = NULL;
	sub_pmes = NULL;
	sub_tu = NULL;
	station_id = NULL;
	station_name = NULL;
	station_pagsal = NULL;
	station_ak = NULL;
	station_pqg1 = NULL;
	station_pqg = NULL;
	station_sal = NULL;
	MrkId = NULL;
	MrkTime = NULL;
	MrkType = NULL;
	MrkName = NULL;
	MrkSymbol = NULL;
	MrkIcon = NULL;
	MrkX = NULL;
	MrkY = NULL;
	MrkTypeEq = NULL;
	MrkCodeEq = NULL;
	MrkEqName = NULL;
	MrkSubDispName = NULL;
	MrkComment = NULL;
	MrkAuthor = NULL;
	zvk_Id = NULL;
	zvk_Avar = NULL;
	zvk_State = NULL;
	zvk_BegTime = NULL;
	zvk_EndTime = NULL;
	zvk_DevType = NULL;
	zvk_DevId = NULL;
	zvk_DevName = NULL;
	zvk_SubId = NULL;
	zvk_SubDispName = NULL;
	ShowMode = NULL;
	StateTimeFilter = NULL;
	BegTimeFilter = NULL;
	EndTimeFilter = NULL;
	DeviceFilter = NULL;
	StateFilter = NULL;
	Type = NULL;
	ModelId = NULL;
	abr_ts = NULL;
	abr_name = NULL;
	abr_SubId = NULL;
	abr_type = NULL;
	abr_volt0 = NULL;
	abr_OperCur = NULL;
	abr_CanSync = NULL;
	abr_SyncState = NULL;
	abr_NeedCheck = NULL;
	abr_per1 = NULL;
	abr_peq1 = NULL;
	abr_tok1 = NULL;
	abr_per2 = NULL;
	abr_peq2 = NULL;
	abr_tok2 = NULL;
	tsn_id = NULL;
	tsn_name = NULL;
	tsn_SubId = NULL;
	tsn_volt0 = NULL;
	tsn_on = NULL;
	tsn_aload = NULL;
	tsn_rload = NULL;
	tsn_moved = NULL;
	trans1_id = NULL;
	trans1_name = NULL;
	trans1_SubId = NULL;
	trans1_volt0 = NULL;
	trans1_on = NULL;
	trans1_aload = NULL;
	trans1_rload = NULL;
	trans2_id = NULL;
	trans2_SubDispname = NULL;
	trans2_FullName = NULL;
	trans2_name = NULL;
	trans2_Unom1 = NULL;
	trans2_Unom2 = NULL;
	trans2_Snom = NULL;
	trans2_SubId = NULL;
	trans2_bkl = NULL;
	trans2_S = NULL;
	trans2_per = NULL;
	trans2_peq = NULL;
	trans2_Inom1 = NULL;
	trans2_per1 = NULL;
	trans2_peq1 = NULL;
	trans2_S1 = NULL;
	trans2_Inom2 = NULL;
	trans2_per2 = NULL;
	trans2_peq2 = NULL;
	trans2_S2 = NULL;
	trans2_tok1 = NULL;
	trans2_tok2 = NULL;
	trans2_SubInd = NULL;
	trans2_RpnState = NULL;
	trans2_DDopVn = NULL;
	trans2_DDopNn = NULL;
	trans2_DdopTimeVn = NULL;
	trans2_DdopTimeNn = NULL;
	trans2_DdopCountVn = NULL;
	trans2_DdopCountNn = NULL;
	trans2_arnt_p = NULL;
	trans2_arnt_t = NULL;
	trans2_IsAdopVn = NULL;
	trans2_IsAdopNn = NULL;
	trans2_AdopCountVn = NULL;
	trans2_AdopCountNn = NULL;
	trans2_IsDdopVn = NULL;
	trans2_IsDdopNn = NULL;
	trans3_id = NULL;
	trans3_SubDispname = NULL;
	trans3_FullName = NULL;
	trans3_name = NULL;
	trans3_SubId = NULL;
	trans3_Unom1 = NULL;
	trans3_Unom2 = NULL;
	trans3_Unom3 = NULL;
	trans3_Snom = NULL;
	trans3_Inom1 = NULL;
	trans3_Inom2 = NULL;
	trans3_SubInd = NULL;
	trans3_per1 = NULL;
	trans3_per2 = NULL;
	trans3_per3 = NULL;
	trans3_peq1 = NULL;
	trans3_peq2 = NULL;
	trans3_peq3 = NULL;
	trans3_tok1 = NULL;
	trans3_tok2 = NULL;
	trans3_tok3 = NULL;
	trans3_S1 = NULL;
	trans3_RpnState = NULL;
	trans3_DDopVn = NULL;
	trans3_DDopSn = NULL;
	trans3_DDopNn = NULL;
	trans3_DdopTimeVn = NULL;
	trans3_DdopTimeSn = NULL;
	trans3_DdopTimeNn = NULL;
	trans3_DdopCountVn = NULL;
	trans3_DdopCountSn = NULL;
	trans3_DdopCountNn = NULL;
	trans3_arnt_p = NULL;
	trans3_arnt_t = NULL;
	trans3_IsAdopVn = NULL;
	trans3_IsAdopSn = NULL;
	trans3_IsAdopNn = NULL;
	trans3_AdopCountVn = NULL;
	trans3_AdopCountSn = NULL;
	trans3_AdopCountNn = NULL;
	trans3_IsDdopVn = NULL;
	trans3_IsDdopSn = NULL;
	trans3_IsDdopNn = NULL;
	fdr_id = NULL;
	fdr_name = NULL;
	fdr_SubId = NULL;
	fdr_volt0 = NULL;
	fdr_on = NULL;
	fdr_aload = NULL;
	fdr_rload = NULL;
	mbr_ts = NULL;
	mbr_name = NULL;
	mbr_SubId = NULL;
	mbr_type = NULL;
	mbr_volt0 = NULL;
	mbr_OperCur = NULL;
	mbr_slot2 = NULL;
	mbr_per1 = NULL;
	mbr_peq1 = NULL;
	mbr_per2 = NULL;
	mbr_peq2 = NULL;
	bus_id = NULL;
	bus_subid = NULL;
	bus_subind = NULL;
	bus_type = NULL;
	bus_SubDispname = NULL;
	bus_name = NULL;
	bus_volt0 = NULL;
	bus_umin = NULL;
	bus_umax = NULL;
	bus_mdlind = NULL;
	bus_mdlid = NULL;
	bus_volt = NULL;
	bus_freq = NULL;
	bus_p = NULL;
	bus_q = NULL;
	bus_g = NULL;
	bus_aki = NULL;
	bus_qmax = NULL;
	bus_qmin = NULL;
	bus_ust_u = NULL;
	bus_Fixation = NULL;
	bus_dead = NULL;
	bus_DdopTime = NULL;
	bus_IsDdop = NULL;
	bus_DdopCount = NULL;
	fbus_id = NULL;
	fbus_subid = NULL;
	fbus_subind = NULL;
	fbus_name = NULL;
	fbus_volt0 = NULL;
	fbus_mdlind = NULL;
	fbus_mdlid = NULL;
	fbus_mdlType = NULL;
	fbus_volt = NULL;
	line_id = NULL;
	line_name = NULL;
	line_volt0 = NULL;
	line_per = NULL;
	line_peq = NULL;
	line_tok = NULL;
	line_per1 = NULL;
	line_peq1 = NULL;
	line_tok1 = NULL;
	line_per2 = NULL;
	line_peq2 = NULL;
	line_tok2 = NULL;
	line_bkl = NULL;
	line_kvit = NULL;
	line_inval = NULL;
	line_SubId1 = NULL;
	line_SubId2 = NULL;
	line_dead = NULL;
	line_Ddop = NULL;
	line_Adop = NULL;
	line_u1 = NULL;
	line_u2 = NULL;
	line_AopoTime = NULL;
	line_aopoTok = NULL;
	line_DdopTime = NULL;
	line_IsDdop = NULL;
	line_DdopCount = NULL;
	line_IsAdop = NULL;
	line_AdopCount = NULL;
	liml_Lnum = NULL;
	liml_Name = NULL;
	liml_Unom = NULL;
	liml_DdopTOE = NULL;
	liml_AdopTOE = NULL;
	liml_I = NULL;
	liml_Ddop = NULL;
	liml_Adop = NULL;
	liml_DdopM20 = NULL;
	liml_AdopM20 = NULL;
	liml_DdopM15 = NULL;
	liml_AdopM15 = NULL;
	liml_DdopM10 = NULL;
	liml_AdopM10 = NULL;
	liml_DdopM5 = NULL;
	liml_AdopM5 = NULL;
	liml_Ddop0 = NULL;
	liml_Adop0 = NULL;
	liml_Ddop5 = NULL;
	liml_Adop5 = NULL;
	liml_Ddop10 = NULL;
	liml_Adop10 = NULL;
	liml_Ddop15 = NULL;
	liml_Adop15 = NULL;
	liml_Ddop20 = NULL;
	liml_Adop20 = NULL;
	liml_Ddop25 = NULL;
	liml_Adop25 = NULL;
	liml_Ddop30 = NULL;
	liml_Adop30 = NULL;
	liml_Ddop35 = NULL;
	liml_Adop35 = NULL;
	liml_Ddop40 = NULL;
	liml_Adop40 = NULL;
	limv_SubId = NULL;
	limv_SubInd = NULL;
	limv_SubDispname = NULL;
	limv_Unom = NULL;
	limv_Umin = NULL;
	limv_Umax = NULL;
	limv_ExcepBuses = NULL;
	limvb_BusId = NULL;
	limvb_BusName = NULL;
	limvb_SubDispname = NULL;
	limvb_Unom = NULL;
	limvb_Umin = NULL;
	limvb_Umax = NULL;
	limvb_U = NULL;
	limvb_Out = NULL;
	tn_id = NULL;
	tn_name = NULL;
	tn_SubId = NULL;
	tn_volt0 = NULL;
	tn_res = NULL;
	tn_nn = NULL;
	tn_Ua = NULL;
	tn_Ub = NULL;
	tn_Uc = NULL;
	tn_Uab = NULL;
	tn_Ubc = NULL;
	tn_Uca = NULL;
	archm = NULL;
	Top = NULL;
	IsolGrn = NULL;
	AvrOn = NULL;
	LoadMode = NULL;
	LoadTime = NULL;
	ViewTime = NULL;
	schema = NULL;
	LoadFile = NULL;
	ShowModel = NULL;
	ShowOik = NULL;
	LineViewMode = NULL;
	CurTemp = NULL;
	WinterNow = NULL;
	NeedSaveSlice = NULL;
	IdDopMaxTime = NULL;
	IdDopTransMaxTime = NULL;
	IdDopTransPercent = NULL;
	Mode = NULL;
	TimeMode = NULL;
	Beg = NULL;
	End = NULL;
	DevMask = NULL;
	StateMask = NULL;
	gen_id = NULL;
	gen_subid = NULL;
	gen_name = NULL;
	gen_volt0 = NULL;
	gen_val = NULL;
	gen_aki = NULL;
	gen_rgen = NULL;
	gen_qmin = NULL;
	gen_qmax = NULL;
	gen_pagsal = NULL;
	gen_sal = NULL;
	gen_ust_u = NULL;
	gen_aload = NULL;
	gen_rload = NULL;
	gen_on = NULL;
	gen_mdlind = NULL;
	gen_mdlid = NULL;
	hbr_ts = NULL;
	hbr_name = NULL;
	hbr_SubId = NULL;
	hbr_volt0 = NULL;
	hbr_EmKey = NULL;
	hbr_AbrBlock = NULL;
	hbr_CheckState = NULL;
	hbr_PowerDrive = NULL;
	grn_ts = NULL;
	grn_name = NULL;
	grn_SubId = NULL;
	grn_volt0 = NULL;
	grn_CheckVolt = NULL;
	grn_short = NULL;
	rct_id = NULL;
	rct_name = NULL;
	rct_SubId = NULL;
	rct_volt0 = NULL;
	rct_p = NULL;
	rct_q = NULL;
	rct_on = NULL;
	frct_id = NULL;
	frct_name = NULL;
	frct_SubId = NULL;
	frct_volt0 = NULL;
	frct_q = NULL;
	frct_qmin = NULL;
	frct_qmax = NULL;
	frct_ust_u = NULL;
	frct_on = NULL;
	frct_mdlind = NULL;
	frct_mdlid = NULL;
	stk_id = NULL;
	stk_name = NULL;
	stk_SubId = NULL;
	stk_volt0 = NULL;
	stk_qg = NULL;
	stk_qmin = NULL;
	stk_qmax = NULL;
	stk_ust_q = NULL;
	stk_ust_u = NULL;
	stk_on = NULL;
	stk_mdlind = NULL;
	stk_mdlid = NULL;
	usr_name = NULL;
	usr_comp = NULL;
	usr_type = NULL;
	top_SubId = NULL;
	top_Action = NULL;
	top_TypeDevice = NULL;
	top_Device = NULL;
	toplog_number = NULL;
	toplog_oldstate = NULL;
	toplog_newstate = NULL;
	toplog_action = NULL;
	toplog_object = NULL;
	toplog_objname = NULL;
	toplog_message = NULL;
	toplog_rating = NULL;

	ReleaseMutex(hMutex);
	CloseHandle(hMutex);

	return 0;
}

LPVOID trenBuf = NULL;
HANDLE trenMap = NULL;

struct sTable *ptrenSdf = NULL;

int trenOpen(const char* name)
{
	DWORD off = 0;
	BYTE offset = 0;
	int result = 0;
	char *p = 0;
	char *pBase = 0;
	char fname[MAX_PATH] = {0};
	char mname[MAX_PATH] = {0};
	HANDLE hMutex     = 0;
	HANDLE hFile      = 0;
	DWORD  sizeFile   = 0;
	int   indexTable = -1;

	if(name == NULL)
		strcpy(fname, "tren.sdf");
	else
		strcpy(fname, (const char*)name);

	if(strchr(fname, ':') == NULL){
		char dir[MAX_PATH] = {0};
		GetModuleFileNameA(NULL, dir, sizeof(dir));
		*(strrchr(dir, '\\') + 1) = '\0';
		strcat(dir, fname);
		strcpy(fname,dir);
	}

	GetFullPathNameA(fname, sizeof(mname), mname, &p);
	//GetLongPathName(fname, mname, sizeof(mname));
	_strlwr(mname);

	p=mname;
	while(*p){
		if(*p<'0') *p= '_';
		if(*p>'9' && *p<'A') *p= '_';
		if(*p>'z') *p= '_';
		if(*p>'Z' && *p<'a') *p= '_';
		p++;
	}

	hMutex = CreateMutexA(NULL, FALSE, "__tren_mutex");

	WaitForSingleObject(hMutex, INFINITE);

	trenMap = OpenFileMappingA(FILE_MAP_ALL_ACCESS, FALSE, mname);

	if(trenMap == NULL){

		hFile = CreateFileA(fname, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
		if(hFile == INVALID_HANDLE_VALUE)
			return trenError(hMutex);

		sizeFile = GetFileSize(hFile, NULL);

		trenMap = CreateFileMappingA(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, sizeFile, mname);
		if(trenMap == NULL)
			return trenError(hMutex);

		trenBuf = MapViewOfFile(trenMap, FILE_MAP_ALL_ACCESS, 0, 0, 0);
		if(trenBuf == NULL)
			return trenError(hMutex);

		if(!ReadFile(hFile, trenBuf, sizeFile, &sizeFile, NULL))
			return trenError(hMutex);

		CloseHandle(hFile);

		result = 2;

	}
	else{

		trenBuf = MapViewOfFile(trenMap, FILE_MAP_ALL_ACCESS, 0, 0, 0);
		if(trenBuf == NULL)
			return trenError(hMutex);

		result = 1;
	}

	pBase = (char*)trenBuf;

	GetInfoAboutSdf(pBase, &ptrenSdf);

	indexTable = FindTable(ptrenSdf, "arnt");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_arnt = GetTableRecordsAddress(ptrenSdf, indexTable);
		arnt_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "DDopVoltLim");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_DDopVoltLim = GetTableRecordsAddress(ptrenSdf, indexTable);
		DDopVoltLim_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "Umax");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_Umax = GetTableRecordsAddress(ptrenSdf, indexTable);
		Umax_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "gvo");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_gvo = GetTableRecordsAddress(ptrenSdf, indexTable);
		gvo_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "aopo");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_aopo = GetTableRecordsAddress(ptrenSdf, indexTable);
		aopo_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "aosn");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_aosn = GetTableRecordsAddress(ptrenSdf, indexTable);
		aosn_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "avr");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_avr = GetTableRecordsAddress(ptrenSdf, indexTable);
		avr_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "TsLog");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_TsLog = GetTableRecordsAddress(ptrenSdf, indexTable);
		TsLog_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "EndLines");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_EndLines = GetTableRecordsAddress(ptrenSdf, indexTable);
		EndLines_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "substn");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_substn = GetTableRecordsAddress(ptrenSdf, indexTable);
		substn_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "station");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_station = GetTableRecordsAddress(ptrenSdf, indexTable);
		station_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "Marks");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_Marks = GetTableRecordsAddress(ptrenSdf, indexTable);
		Marks_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "Zvk");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_Zvk = GetTableRecordsAddress(ptrenSdf, indexTable);
		Zvk_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "sms_zvk");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_sms_zvk = GetTableRecordsAddress(ptrenSdf, indexTable);
		sms_zvk_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "zvkdevices");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_zvkdevices = GetTableRecordsAddress(ptrenSdf, indexTable);
		zvkdevices_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "abr");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_abr = GetTableRecordsAddress(ptrenSdf, indexTable);
		abr_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "tsn");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_tsn = GetTableRecordsAddress(ptrenSdf, indexTable);
		tsn_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "trans1");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_trans1 = GetTableRecordsAddress(ptrenSdf, indexTable);
		trans1_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "trans2");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_trans2 = GetTableRecordsAddress(ptrenSdf, indexTable);
		trans2_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "trans3");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_trans3 = GetTableRecordsAddress(ptrenSdf, indexTable);
		trans3_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "fdr");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_fdr = GetTableRecordsAddress(ptrenSdf, indexTable);
		fdr_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "mbr");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_mbr = GetTableRecordsAddress(ptrenSdf, indexTable);
		mbr_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "bus");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_bus = GetTableRecordsAddress(ptrenSdf, indexTable);
		bus_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "fbus");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_fbus = GetTableRecordsAddress(ptrenSdf, indexTable);
		fbus_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "line");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_line = GetTableRecordsAddress(ptrenSdf, indexTable);
		line_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "LineLim");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_LineLim = GetTableRecordsAddress(ptrenSdf, indexTable);
		LineLim_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "VoltLim");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_VoltLim = GetTableRecordsAddress(ptrenSdf, indexTable);
		VoltLim_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "VoltLimBus");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_VoltLimBus = GetTableRecordsAddress(ptrenSdf, indexTable);
		VoltLimBus_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "tn");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_tn = GetTableRecordsAddress(ptrenSdf, indexTable);
		tn_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "options");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_options = GetTableRecordsAddress(ptrenSdf, indexTable);
		options_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "zayavka");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_zayavka = GetTableRecordsAddress(ptrenSdf, indexTable);
		zayavka_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "gen");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_gen = GetTableRecordsAddress(ptrenSdf, indexTable);
		gen_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "hbr");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_hbr = GetTableRecordsAddress(ptrenSdf, indexTable);
		hbr_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "grn");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_grn = GetTableRecordsAddress(ptrenSdf, indexTable);
		grn_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "rct");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_rct = GetTableRecordsAddress(ptrenSdf, indexTable);
		rct_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "frct");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_frct = GetTableRecordsAddress(ptrenSdf, indexTable);
		frct_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "stk");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_stk = GetTableRecordsAddress(ptrenSdf, indexTable);
		stk_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "users");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_users = GetTableRecordsAddress(ptrenSdf, indexTable);
		users_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "toptask");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_toptask = GetTableRecordsAddress(ptrenSdf, indexTable);
		toptask_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	indexTable = FindTable(ptrenSdf, "toplog");
	if(indexTable == -1)
		return trenError(hMutex);
	else{
		p_toplog = GetTableRecordsAddress(ptrenSdf, indexTable);
		toplog_max = GetTableRecordsMax(ptrenSdf, indexTable);
	}

	offset = GetOffsetData(ptrenSdf, "arnt_leading", &off);
	if(offset)
		arnt_leading = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "arnt_followings", &off);
	if(offset)
		arnt_followings = (c20*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "ddvl_Unom", &off);
	if(offset)
		ddvl_Unom = (c15*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "ddvl_duration", &off);
	if(offset)
		ddvl_duration = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "ddvl_coefficient", &off);
	if(offset)
		ddvl_coefficient = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "ddvl_UnomMin", &off);
	if(offset)
		ddvl_UnomMin = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "ddvl_UnomMax", &off);
	if(offset)
		ddvl_UnomMax = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "umax_nom", &off);
	if(offset)
		umax_nom = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "umax_max", &off);
	if(offset)
		umax_max = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "gvo_SubId", &off);
	if(offset)
		gvo_SubId = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "gvo_Sequen", &off);
	if(offset)
		gvo_Sequen = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "gvo_BrkId", &off);
	if(offset)
		gvo_BrkId = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "gvo_SubName", &off);
	if(offset)
		gvo_SubName = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "gvo_LoadDesc", &off);
	if(offset)
		gvo_LoadDesc = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "gvo_LoadVal", &off);
	if(offset)
		gvo_LoadVal = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "gvo_MaxTime", &off);
	if(offset)
		gvo_MaxTime = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "gvo_Who", &off);
	if(offset)
		gvo_Who = (c10*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "aopo_id", &off);
	if(offset)
		aopo_id = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "aopo_TokLines", &off);
	if(offset)
		aopo_TokLines = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "aopo_TokDesc", &off);
	if(offset)
		aopo_TokDesc = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "aopo_TokSummer", &off);
	if(offset)
		aopo_TokSummer = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "aopo_TokWinter", &off);
	if(offset)
		aopo_TokWinter = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "aopo_LoadBreakers", &off);
	if(offset)
		aopo_LoadBreakers = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "aopo_LoadDesc", &off);
	if(offset)
		aopo_LoadDesc = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "aopo_LineBreakers", &off);
	if(offset)
		aopo_LineBreakers = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "aopo_work", &off);
	if(offset)
		aopo_work = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "aopo_out", &off);
	if(offset)
		aopo_out = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "aosn_id", &off);
	if(offset)
		aosn_id = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "aosn_VoltBuses", &off);
	if(offset)
		aosn_VoltBuses = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "aosn_VoltDesc", &off);
	if(offset)
		aosn_VoltDesc = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "aosn_VoltMin", &off);
	if(offset)
		aosn_VoltMin = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "aosn_OffBreakers", &off);
	if(offset)
		aosn_OffBreakers = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "aosn_OffDesc", &off);
	if(offset)
		aosn_OffDesc = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "aosn_time", &off);
	if(offset)
		aosn_time = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "aosn_work", &off);
	if(offset)
		aosn_work = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "aosn_out", &off);
	if(offset)
		aosn_out = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "avr_id", &off);
	if(offset)
		avr_id = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "avr_name", &off);
	if(offset)
		avr_name = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "avr_subid", &off);
	if(offset)
		avr_subid = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "avr_volt0", &off);
	if(offset)
		avr_volt0 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "avr_ts0", &off);
	if(offset)
		avr_ts0 = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "avr_ts1", &off);
	if(offset)
		avr_ts1 = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "avr_ts2", &off);
	if(offset)
		avr_ts2 = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "avr_algo", &off);
	if(offset)
		avr_algo = (c4*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "avr_work", &off);
	if(offset)
		avr_work = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "avr_out", &off);
	if(offset)
		avr_out = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "avr_bus1", &off);
	if(offset)
		avr_bus1 = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "avr_bus2", &off);
	if(offset)
		avr_bus2 = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "tslog_DevId", &off);
	if(offset)
		tslog_DevId = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "tslog_DevName", &off);
	if(offset)
		tslog_DevName = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "tslog_TsType", &off);
	if(offset)
		tslog_TsType = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "tslog_SubId", &off);
	if(offset)
		tslog_SubId = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "tslog_SubDispName", &off);
	if(offset)
		tslog_SubDispName = (c30*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "tslog_NewState", &off);
	if(offset)
		tslog_NewState = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "tslog_Tim", &off);
	if(offset)
		tslog_Tim = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "eline_id", &off);
	if(offset)
		eline_id = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "eline_subid", &off);
	if(offset)
		eline_subid = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "eline_name", &off);
	if(offset)
		eline_name = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "eline_volt0", &off);
	if(offset)
		eline_volt0 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "eline_p", &off);
	if(offset)
		eline_p = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "eline_q", &off);
	if(offset)
		eline_q = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "eline_i", &off);
	if(offset)
		eline_i = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "eline_p0", &off);
	if(offset)
		eline_p0 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "eline_q0", &off);
	if(offset)
		eline_q0 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "eline_on", &off);
	if(offset)
		eline_on = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "sub_id", &off);
	if(offset)
		sub_id = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "sub_name", &off);
	if(offset)
		sub_name = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "sub_name1", &off);
	if(offset)
		sub_name1 = (c20*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "sub_folder", &off);
	if(offset)
		sub_folder = (c12*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "sub_dispname", &off);
	if(offset)
		sub_dispname = (c30*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "sub_volt0", &off);
	if(offset)
		sub_volt0 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "sub_isstation", &off);
	if(offset)
		sub_isstation = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "sub_volt", &off);
	if(offset)
		sub_volt = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "sub_freq", &off);
	if(offset)
		sub_freq = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "sub_sal1", &off);
	if(offset)
		sub_sal1 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "sub_p", &off);
	if(offset)
		sub_p = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "sub_q", &off);
	if(offset)
		sub_q = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "sub_frct", &off);
	if(offset)
		sub_frct = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "sub_stk", &off);
	if(offset)
		sub_stk = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "sub_open", &off);
	if(offset)
		sub_open = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "sub_file", &off);
	if(offset)
		sub_file = (c255*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "sub_regim", &off);
	if(offset)
		sub_regim = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "sub_avr", &off);
	if(offset)
		sub_avr = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "sub_kvit", &off);
	if(offset)
		sub_kvit = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "sub_pmes", &off);
	if(offset)
		sub_pmes = (c15*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "sub_tu", &off);
	if(offset)
		sub_tu = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "station_id", &off);
	if(offset)
		station_id = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "station_name", &off);
	if(offset)
		station_name = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "station_pagsal", &off);
	if(offset)
		station_pagsal = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "station_ak", &off);
	if(offset)
		station_ak = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "station_pqg1", &off);
	if(offset)
		station_pqg1 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "station_pqg", &off);
	if(offset)
		station_pqg = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "station_sal", &off);
	if(offset)
		station_sal = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "MrkId", &off);
	if(offset)
		MrkId = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "MrkTime", &off);
	if(offset)
		MrkTime = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "MrkType", &off);
	if(offset)
		MrkType = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "MrkName", &off);
	if(offset)
		MrkName = (c30*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "MrkSymbol", &off);
	if(offset)
		MrkSymbol = (c20*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "MrkIcon", &off);
	if(offset)
		MrkIcon = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "MrkX", &off);
	if(offset)
		MrkX = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "MrkY", &off);
	if(offset)
		MrkY = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "MrkTypeEq", &off);
	if(offset)
		MrkTypeEq = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "MrkCodeEq", &off);
	if(offset)
		MrkCodeEq = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "MrkEqName", &off);
	if(offset)
		MrkEqName = (c70*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "MrkSubDispName", &off);
	if(offset)
		MrkSubDispName = (c30*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "MrkComment", &off);
	if(offset)
		MrkComment = (c255*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "MrkAuthor", &off);
	if(offset)
		MrkAuthor = (c150*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "zvk_Id", &off);
	if(offset)
		zvk_Id = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "zvk_Avar", &off);
	if(offset)
		zvk_Avar = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "zvk_State", &off);
	if(offset)
		zvk_State = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "zvk_BegTime", &off);
	if(offset)
		zvk_BegTime = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "zvk_EndTime", &off);
	if(offset)
		zvk_EndTime = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "zvk_DevType", &off);
	if(offset)
		zvk_DevType = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "zvk_DevId", &off);
	if(offset)
		zvk_DevId = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "zvk_DevName", &off);
	if(offset)
		zvk_DevName = (c70*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "zvk_SubId", &off);
	if(offset)
		zvk_SubId = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "zvk_SubDispName", &off);
	if(offset)
		zvk_SubDispName = (c30*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "ShowMode", &off);
	if(offset)
		ShowMode = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "StateTimeFilter", &off);
	if(offset)
		StateTimeFilter = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "BegTimeFilter", &off);
	if(offset)
		BegTimeFilter = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "EndTimeFilter", &off);
	if(offset)
		EndTimeFilter = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "DeviceFilter", &off);
	if(offset)
		DeviceFilter = (c255*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "StateFilter", &off);
	if(offset)
		StateFilter = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "Type", &off);
	if(offset)
		Type = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "ModelId", &off);
	if(offset)
		ModelId = (double*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "abr_ts", &off);
	if(offset)
		abr_ts = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "abr_name", &off);
	if(offset)
		abr_name = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "abr_SubId", &off);
	if(offset)
		abr_SubId = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "abr_type", &off);
	if(offset)
		abr_type = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "abr_volt0", &off);
	if(offset)
		abr_volt0 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "abr_OperCur", &off);
	if(offset)
		abr_OperCur = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "abr_CanSync", &off);
	if(offset)
		abr_CanSync = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "abr_SyncState", &off);
	if(offset)
		abr_SyncState = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "abr_NeedCheck", &off);
	if(offset)
		abr_NeedCheck = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "abr_per1", &off);
	if(offset)
		abr_per1 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "abr_peq1", &off);
	if(offset)
		abr_peq1 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "abr_tok1", &off);
	if(offset)
		abr_tok1 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "abr_per2", &off);
	if(offset)
		abr_per2 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "abr_peq2", &off);
	if(offset)
		abr_peq2 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "abr_tok2", &off);
	if(offset)
		abr_tok2 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "tsn_id", &off);
	if(offset)
		tsn_id = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "tsn_name", &off);
	if(offset)
		tsn_name = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "tsn_SubId", &off);
	if(offset)
		tsn_SubId = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "tsn_volt0", &off);
	if(offset)
		tsn_volt0 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "tsn_on", &off);
	if(offset)
		tsn_on = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "tsn_aload", &off);
	if(offset)
		tsn_aload = (double*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "tsn_rload", &off);
	if(offset)
		tsn_rload = (double*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "tsn_moved", &off);
	if(offset)
		tsn_moved = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans1_id", &off);
	if(offset)
		trans1_id = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans1_name", &off);
	if(offset)
		trans1_name = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans1_SubId", &off);
	if(offset)
		trans1_SubId = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans1_volt0", &off);
	if(offset)
		trans1_volt0 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans1_on", &off);
	if(offset)
		trans1_on = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans1_aload", &off);
	if(offset)
		trans1_aload = (double*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans1_rload", &off);
	if(offset)
		trans1_rload = (double*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_id", &off);
	if(offset)
		trans2_id = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_SubDispname", &off);
	if(offset)
		trans2_SubDispname = (c30*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_FullName", &off);
	if(offset)
		trans2_FullName = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_name", &off);
	if(offset)
		trans2_name = (c10*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_Unom1", &off);
	if(offset)
		trans2_Unom1 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_Unom2", &off);
	if(offset)
		trans2_Unom2 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_Snom", &off);
	if(offset)
		trans2_Snom = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_SubId", &off);
	if(offset)
		trans2_SubId = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_bkl", &off);
	if(offset)
		trans2_bkl = (char*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_S", &off);
	if(offset)
		trans2_S = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_per", &off);
	if(offset)
		trans2_per = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_peq", &off);
	if(offset)
		trans2_peq = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_Inom1", &off);
	if(offset)
		trans2_Inom1 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_per1", &off);
	if(offset)
		trans2_per1 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_peq1", &off);
	if(offset)
		trans2_peq1 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_S1", &off);
	if(offset)
		trans2_S1 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_Inom2", &off);
	if(offset)
		trans2_Inom2 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_per2", &off);
	if(offset)
		trans2_per2 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_peq2", &off);
	if(offset)
		trans2_peq2 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_S2", &off);
	if(offset)
		trans2_S2 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_tok1", &off);
	if(offset)
		trans2_tok1 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_tok2", &off);
	if(offset)
		trans2_tok2 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_SubInd", &off);
	if(offset)
		trans2_SubInd = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_RpnState", &off);
	if(offset)
		trans2_RpnState = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_DDopVn", &off);
	if(offset)
		trans2_DDopVn = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_DDopNn", &off);
	if(offset)
		trans2_DDopNn = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_DdopTimeVn", &off);
	if(offset)
		trans2_DdopTimeVn = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_DdopTimeNn", &off);
	if(offset)
		trans2_DdopTimeNn = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_DdopCountVn", &off);
	if(offset)
		trans2_DdopCountVn = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_DdopCountNn", &off);
	if(offset)
		trans2_DdopCountNn = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_arnt_p", &off);
	if(offset)
		trans2_arnt_p = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_arnt_t", &off);
	if(offset)
		trans2_arnt_t = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_IsAdopVn", &off);
	if(offset)
		trans2_IsAdopVn = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_IsAdopNn", &off);
	if(offset)
		trans2_IsAdopNn = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_AdopCountVn", &off);
	if(offset)
		trans2_AdopCountVn = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_AdopCountNn", &off);
	if(offset)
		trans2_AdopCountNn = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_IsDdopVn", &off);
	if(offset)
		trans2_IsDdopVn = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans2_IsDdopNn", &off);
	if(offset)
		trans2_IsDdopNn = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_id", &off);
	if(offset)
		trans3_id = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_SubDispname", &off);
	if(offset)
		trans3_SubDispname = (c30*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_FullName", &off);
	if(offset)
		trans3_FullName = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_name", &off);
	if(offset)
		trans3_name = (c10*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_SubId", &off);
	if(offset)
		trans3_SubId = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_Unom1", &off);
	if(offset)
		trans3_Unom1 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_Unom2", &off);
	if(offset)
		trans3_Unom2 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_Unom3", &off);
	if(offset)
		trans3_Unom3 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_Snom", &off);
	if(offset)
		trans3_Snom = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_Inom1", &off);
	if(offset)
		trans3_Inom1 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_Inom2", &off);
	if(offset)
		trans3_Inom2 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_SubInd", &off);
	if(offset)
		trans3_SubInd = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_per1", &off);
	if(offset)
		trans3_per1 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_per2", &off);
	if(offset)
		trans3_per2 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_per3", &off);
	if(offset)
		trans3_per3 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_peq1", &off);
	if(offset)
		trans3_peq1 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_peq2", &off);
	if(offset)
		trans3_peq2 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_peq3", &off);
	if(offset)
		trans3_peq3 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_tok1", &off);
	if(offset)
		trans3_tok1 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_tok2", &off);
	if(offset)
		trans3_tok2 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_tok3", &off);
	if(offset)
		trans3_tok3 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_S1", &off);
	if(offset)
		trans3_S1 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_RpnState", &off);
	if(offset)
		trans3_RpnState = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_DDopVn", &off);
	if(offset)
		trans3_DDopVn = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_DDopSn", &off);
	if(offset)
		trans3_DDopSn = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_DDopNn", &off);
	if(offset)
		trans3_DDopNn = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_DdopTimeVn", &off);
	if(offset)
		trans3_DdopTimeVn = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_DdopTimeSn", &off);
	if(offset)
		trans3_DdopTimeSn = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_DdopTimeNn", &off);
	if(offset)
		trans3_DdopTimeNn = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_DdopCountVn", &off);
	if(offset)
		trans3_DdopCountVn = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_DdopCountSn", &off);
	if(offset)
		trans3_DdopCountSn = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_DdopCountNn", &off);
	if(offset)
		trans3_DdopCountNn = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_arnt_p", &off);
	if(offset)
		trans3_arnt_p = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_arnt_t", &off);
	if(offset)
		trans3_arnt_t = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_IsAdopVn", &off);
	if(offset)
		trans3_IsAdopVn = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_IsAdopSn", &off);
	if(offset)
		trans3_IsAdopSn = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_IsAdopNn", &off);
	if(offset)
		trans3_IsAdopNn = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_AdopCountVn", &off);
	if(offset)
		trans3_AdopCountVn = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_AdopCountSn", &off);
	if(offset)
		trans3_AdopCountSn = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_AdopCountNn", &off);
	if(offset)
		trans3_AdopCountNn = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_IsDdopVn", &off);
	if(offset)
		trans3_IsDdopVn = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_IsDdopSn", &off);
	if(offset)
		trans3_IsDdopSn = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "trans3_IsDdopNn", &off);
	if(offset)
		trans3_IsDdopNn = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "fdr_id", &off);
	if(offset)
		fdr_id = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "fdr_name", &off);
	if(offset)
		fdr_name = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "fdr_SubId", &off);
	if(offset)
		fdr_SubId = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "fdr_volt0", &off);
	if(offset)
		fdr_volt0 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "fdr_on", &off);
	if(offset)
		fdr_on = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "fdr_aload", &off);
	if(offset)
		fdr_aload = (double*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "fdr_rload", &off);
	if(offset)
		fdr_rload = (double*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "mbr_ts", &off);
	if(offset)
		mbr_ts = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "mbr_name", &off);
	if(offset)
		mbr_name = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "mbr_SubId", &off);
	if(offset)
		mbr_SubId = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "mbr_type", &off);
	if(offset)
		mbr_type = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "mbr_volt0", &off);
	if(offset)
		mbr_volt0 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "mbr_OperCur", &off);
	if(offset)
		mbr_OperCur = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "mbr_slot2", &off);
	if(offset)
		mbr_slot2 = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "mbr_per1", &off);
	if(offset)
		mbr_per1 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "mbr_peq1", &off);
	if(offset)
		mbr_peq1 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "mbr_per2", &off);
	if(offset)
		mbr_per2 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "mbr_peq2", &off);
	if(offset)
		mbr_peq2 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "bus_id", &off);
	if(offset)
		bus_id = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "bus_subid", &off);
	if(offset)
		bus_subid = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "bus_subind", &off);
	if(offset)
		bus_subind = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "bus_type", &off);
	if(offset)
		bus_type = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "bus_SubDispname", &off);
	if(offset)
		bus_SubDispname = (c30*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "bus_name", &off);
	if(offset)
		bus_name = (c15*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "bus_volt0", &off);
	if(offset)
		bus_volt0 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "bus_umin", &off);
	if(offset)
		bus_umin = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "bus_umax", &off);
	if(offset)
		bus_umax = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "bus_mdlind", &off);
	if(offset)
		bus_mdlind = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "bus_mdlid", &off);
	if(offset)
		bus_mdlid = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "bus_volt", &off);
	if(offset)
		bus_volt = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "bus_freq", &off);
	if(offset)
		bus_freq = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "bus_p", &off);
	if(offset)
		bus_p = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "bus_q", &off);
	if(offset)
		bus_q = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "bus_g", &off);
	if(offset)
		bus_g = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "bus_aki", &off);
	if(offset)
		bus_aki = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "bus_qmax", &off);
	if(offset)
		bus_qmax = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "bus_qmin", &off);
	if(offset)
		bus_qmin = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "bus_ust_u", &off);
	if(offset)
		bus_ust_u = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "bus_Fixation", &off);
	if(offset)
		bus_Fixation = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "bus_dead", &off);
	if(offset)
		bus_dead = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "bus_DdopTime", &off);
	if(offset)
		bus_DdopTime = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "bus_IsDdop", &off);
	if(offset)
		bus_IsDdop = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "bus_DdopCount", &off);
	if(offset)
		bus_DdopCount = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "fbus_id", &off);
	if(offset)
		fbus_id = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "fbus_subid", &off);
	if(offset)
		fbus_subid = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "fbus_subind", &off);
	if(offset)
		fbus_subind = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "fbus_name", &off);
	if(offset)
		fbus_name = (c15*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "fbus_volt0", &off);
	if(offset)
		fbus_volt0 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "fbus_mdlind", &off);
	if(offset)
		fbus_mdlind = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "fbus_mdlid", &off);
	if(offset)
		fbus_mdlid = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "fbus_mdlType", &off);
	if(offset)
		fbus_mdlType = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "fbus_volt", &off);
	if(offset)
		fbus_volt = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_id", &off);
	if(offset)
		line_id = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_name", &off);
	if(offset)
		line_name = (c70*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_volt0", &off);
	if(offset)
		line_volt0 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_per", &off);
	if(offset)
		line_per = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_peq", &off);
	if(offset)
		line_peq = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_tok", &off);
	if(offset)
		line_tok = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_per1", &off);
	if(offset)
		line_per1 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_peq1", &off);
	if(offset)
		line_peq1 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_tok1", &off);
	if(offset)
		line_tok1 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_per2", &off);
	if(offset)
		line_per2 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_peq2", &off);
	if(offset)
		line_peq2 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_tok2", &off);
	if(offset)
		line_tok2 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_bkl", &off);
	if(offset)
		line_bkl = (char*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_kvit", &off);
	if(offset)
		line_kvit = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_inval", &off);
	if(offset)
		line_inval = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_SubId1", &off);
	if(offset)
		line_SubId1 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_SubId2", &off);
	if(offset)
		line_SubId2 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_dead", &off);
	if(offset)
		line_dead = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_Ddop", &off);
	if(offset)
		line_Ddop = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_Adop", &off);
	if(offset)
		line_Adop = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_u1", &off);
	if(offset)
		line_u1 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_u2", &off);
	if(offset)
		line_u2 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_AopoTime", &off);
	if(offset)
		line_AopoTime = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_aopoTok", &off);
	if(offset)
		line_aopoTok = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_DdopTime", &off);
	if(offset)
		line_DdopTime = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_IsDdop", &off);
	if(offset)
		line_IsDdop = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_DdopCount", &off);
	if(offset)
		line_DdopCount = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_IsAdop", &off);
	if(offset)
		line_IsAdop = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "line_AdopCount", &off);
	if(offset)
		line_AdopCount = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_Lnum", &off);
	if(offset)
		liml_Lnum = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_Name", &off);
	if(offset)
		liml_Name = (c70*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_Unom", &off);
	if(offset)
		liml_Unom = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_DdopTOE", &off);
	if(offset)
		liml_DdopTOE = (c80*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_AdopTOE", &off);
	if(offset)
		liml_AdopTOE = (c80*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_I", &off);
	if(offset)
		liml_I = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_Ddop", &off);
	if(offset)
		liml_Ddop = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_Adop", &off);
	if(offset)
		liml_Adop = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_DdopM20", &off);
	if(offset)
		liml_DdopM20 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_AdopM20", &off);
	if(offset)
		liml_AdopM20 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_DdopM15", &off);
	if(offset)
		liml_DdopM15 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_AdopM15", &off);
	if(offset)
		liml_AdopM15 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_DdopM10", &off);
	if(offset)
		liml_DdopM10 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_AdopM10", &off);
	if(offset)
		liml_AdopM10 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_DdopM5", &off);
	if(offset)
		liml_DdopM5 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_AdopM5", &off);
	if(offset)
		liml_AdopM5 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_Ddop0", &off);
	if(offset)
		liml_Ddop0 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_Adop0", &off);
	if(offset)
		liml_Adop0 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_Ddop5", &off);
	if(offset)
		liml_Ddop5 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_Adop5", &off);
	if(offset)
		liml_Adop5 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_Ddop10", &off);
	if(offset)
		liml_Ddop10 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_Adop10", &off);
	if(offset)
		liml_Adop10 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_Ddop15", &off);
	if(offset)
		liml_Ddop15 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_Adop15", &off);
	if(offset)
		liml_Adop15 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_Ddop20", &off);
	if(offset)
		liml_Ddop20 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_Adop20", &off);
	if(offset)
		liml_Adop20 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_Ddop25", &off);
	if(offset)
		liml_Ddop25 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_Adop25", &off);
	if(offset)
		liml_Adop25 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_Ddop30", &off);
	if(offset)
		liml_Ddop30 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_Adop30", &off);
	if(offset)
		liml_Adop30 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_Ddop35", &off);
	if(offset)
		liml_Ddop35 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_Adop35", &off);
	if(offset)
		liml_Adop35 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_Ddop40", &off);
	if(offset)
		liml_Ddop40 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "liml_Adop40", &off);
	if(offset)
		liml_Adop40 = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "limv_SubId", &off);
	if(offset)
		limv_SubId = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "limv_SubInd", &off);
	if(offset)
		limv_SubInd = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "limv_SubDispname", &off);
	if(offset)
		limv_SubDispname = (c30*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "limv_Unom", &off);
	if(offset)
		limv_Unom = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "limv_Umin", &off);
	if(offset)
		limv_Umin = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "limv_Umax", &off);
	if(offset)
		limv_Umax = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "limv_ExcepBuses", &off);
	if(offset)
		limv_ExcepBuses = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "limvb_BusId", &off);
	if(offset)
		limvb_BusId = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "limvb_BusName", &off);
	if(offset)
		limvb_BusName = (c15*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "limvb_SubDispname", &off);
	if(offset)
		limvb_SubDispname = (c30*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "limvb_Unom", &off);
	if(offset)
		limvb_Unom = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "limvb_Umin", &off);
	if(offset)
		limvb_Umin = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "limvb_Umax", &off);
	if(offset)
		limvb_Umax = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "limvb_U", &off);
	if(offset)
		limvb_U = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "limvb_Out", &off);
	if(offset)
		limvb_Out = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "tn_id", &off);
	if(offset)
		tn_id = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "tn_name", &off);
	if(offset)
		tn_name = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "tn_SubId", &off);
	if(offset)
		tn_SubId = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "tn_volt0", &off);
	if(offset)
		tn_volt0 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "tn_res", &off);
	if(offset)
		tn_res = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "tn_nn", &off);
	if(offset)
		tn_nn = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "tn_Ua", &off);
	if(offset)
		tn_Ua = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "tn_Ub", &off);
	if(offset)
		tn_Ub = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "tn_Uc", &off);
	if(offset)
		tn_Uc = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "tn_Uab", &off);
	if(offset)
		tn_Uab = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "tn_Ubc", &off);
	if(offset)
		tn_Ubc = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "tn_Uca", &off);
	if(offset)
		tn_Uca = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "archm", &off);
	if(offset)
		archm = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "Top", &off);
	if(offset)
		Top = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "IsolGrn", &off);
	if(offset)
		IsolGrn = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "AvrOn", &off);
	if(offset)
		AvrOn = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "LoadMode", &off);
	if(offset)
		LoadMode = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "LoadTime", &off);
	if(offset)
		LoadTime = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "ViewTime", &off);
	if(offset)
		ViewTime = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "schema", &off);
	if(offset)
		schema = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "LoadFile", &off);
	if(offset)
		LoadFile = (c70*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "ShowModel", &off);
	if(offset)
		ShowModel = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "ShowOik", &off);
	if(offset)
		ShowOik = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "LineViewMode", &off);
	if(offset)
		LineViewMode = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "CurTemp", &off);
	if(offset)
		CurTemp = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "WinterNow", &off);
	if(offset)
		WinterNow = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "NeedSaveSlice", &off);
	if(offset)
		NeedSaveSlice = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "IdDopMaxTime", &off);
	if(offset)
		IdDopMaxTime = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "IdDopTransMaxTime", &off);
	if(offset)
		IdDopTransMaxTime = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "IdDopTransPercent", &off);
	if(offset)
		IdDopTransPercent = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "Mode", &off);
	if(offset)
		Mode = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "TimeMode", &off);
	if(offset)
		TimeMode = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "Beg", &off);
	if(offset)
		Beg = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "End", &off);
	if(offset)
		End = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "DevMask", &off);
	if(offset)
		DevMask = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "StateMask", &off);
	if(offset)
		StateMask = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "gen_id", &off);
	if(offset)
		gen_id = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "gen_subid", &off);
	if(offset)
		gen_subid = (short*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "gen_name", &off);
	if(offset)
		gen_name = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "gen_volt0", &off);
	if(offset)
		gen_volt0 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "gen_val", &off);
	if(offset)
		gen_val = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "gen_aki", &off);
	if(offset)
		gen_aki = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "gen_rgen", &off);
	if(offset)
		gen_rgen = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "gen_qmin", &off);
	if(offset)
		gen_qmin = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "gen_qmax", &off);
	if(offset)
		gen_qmax = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "gen_pagsal", &off);
	if(offset)
		gen_pagsal = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "gen_sal", &off);
	if(offset)
		gen_sal = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "gen_ust_u", &off);
	if(offset)
		gen_ust_u = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "gen_aload", &off);
	if(offset)
		gen_aload = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "gen_rload", &off);
	if(offset)
		gen_rload = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "gen_on", &off);
	if(offset)
		gen_on = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "gen_mdlind", &off);
	if(offset)
		gen_mdlind = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "gen_mdlid", &off);
	if(offset)
		gen_mdlid = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "hbr_ts", &off);
	if(offset)
		hbr_ts = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "hbr_name", &off);
	if(offset)
		hbr_name = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "hbr_SubId", &off);
	if(offset)
		hbr_SubId = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "hbr_volt0", &off);
	if(offset)
		hbr_volt0 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "hbr_EmKey", &off);
	if(offset)
		hbr_EmKey = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "hbr_AbrBlock", &off);
	if(offset)
		hbr_AbrBlock = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "hbr_CheckState", &off);
	if(offset)
		hbr_CheckState = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "hbr_PowerDrive", &off);
	if(offset)
		hbr_PowerDrive = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "grn_ts", &off);
	if(offset)
		grn_ts = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "grn_name", &off);
	if(offset)
		grn_name = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "grn_SubId", &off);
	if(offset)
		grn_SubId = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "grn_volt0", &off);
	if(offset)
		grn_volt0 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "grn_CheckVolt", &off);
	if(offset)
		grn_CheckVolt = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "grn_short", &off);
	if(offset)
		grn_short = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "rct_id", &off);
	if(offset)
		rct_id = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "rct_name", &off);
	if(offset)
		rct_name = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "rct_SubId", &off);
	if(offset)
		rct_SubId = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "rct_volt0", &off);
	if(offset)
		rct_volt0 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "rct_p", &off);
	if(offset)
		rct_p = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "rct_q", &off);
	if(offset)
		rct_q = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "rct_on", &off);
	if(offset)
		rct_on = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "frct_id", &off);
	if(offset)
		frct_id = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "frct_name", &off);
	if(offset)
		frct_name = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "frct_SubId", &off);
	if(offset)
		frct_SubId = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "frct_volt0", &off);
	if(offset)
		frct_volt0 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "frct_q", &off);
	if(offset)
		frct_q = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "frct_qmin", &off);
	if(offset)
		frct_qmin = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "frct_qmax", &off);
	if(offset)
		frct_qmax = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "frct_ust_u", &off);
	if(offset)
		frct_ust_u = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "frct_on", &off);
	if(offset)
		frct_on = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "frct_mdlind", &off);
	if(offset)
		frct_mdlind = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "frct_mdlid", &off);
	if(offset)
		frct_mdlid = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "stk_id", &off);
	if(offset)
		stk_id = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "stk_name", &off);
	if(offset)
		stk_name = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "stk_SubId", &off);
	if(offset)
		stk_SubId = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "stk_volt0", &off);
	if(offset)
		stk_volt0 = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "stk_qg", &off);
	if(offset)
		stk_qg = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "stk_qmin", &off);
	if(offset)
		stk_qmin = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "stk_qmax", &off);
	if(offset)
		stk_qmax = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "stk_ust_q", &off);
	if(offset)
		stk_ust_q = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "stk_ust_u", &off);
	if(offset)
		stk_ust_u = (float*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "stk_on", &off);
	if(offset)
		stk_on = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "stk_mdlind", &off);
	if(offset)
		stk_mdlind = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "stk_mdlid", &off);
	if(offset)
		stk_mdlid = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "usr_name", &off);
	if(offset)
		usr_name = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "usr_comp", &off);
	if(offset)
		usr_comp = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "usr_type", &off);
	if(offset)
		usr_type = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "top_SubId", &off);
	if(offset)
		top_SubId = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "top_Action", &off);
	if(offset)
		top_Action = (c10*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "top_TypeDevice", &off);
	if(offset)
		top_TypeDevice = (c10*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "top_Device", &off);
	if(offset)
		top_Device = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "toplog_number", &off);
	if(offset)
		toplog_number = (int*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "toplog_oldstate", &off);
	if(offset)
		toplog_oldstate = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "toplog_newstate", &off);
	if(offset)
		toplog_newstate = (BYTE*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "toplog_action", &off);
	if(offset)
		toplog_action = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "toplog_object", &off);
	if(offset)
		toplog_object = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "toplog_objname", &off);
	if(offset)
		toplog_objname = (c50*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "toplog_message", &off);
	if(offset)
		toplog_message = (c255*)(pBase + off);
	else
		return trenError(hMutex);

	offset = GetOffsetData(ptrenSdf, "toplog_rating", &off);
	if(offset)
		toplog_rating = (short*)(pBase + off);
	else
		return trenError(hMutex);

	ReleaseMutex(hMutex);
	CloseHandle(hMutex);

	return result;
}

void trenClose()
{
	HANDLE hMutex = 0;
	hMutex = CreateMutexA(NULL, FALSE, "__tren_mutex");
	WaitForSingleObject(hMutex, INFINITE);

	if(ptrenSdf != NULL)
	{
		DeleteInfoSdf(&ptrenSdf);
		ptrenSdf = NULL;
	}

	if(trenBuf)
	{
		UnmapViewOfFile(trenBuf);
		trenBuf = NULL;
	}

	if(trenMap)
	{
		CloseHandle(trenMap);
		trenMap = NULL;
	}

	ReleaseMutex(hMutex);
	CloseHandle(hMutex);
}
